/*
 * GEN.wrapper_posixio.c
 * DO NOT EDIT: automatically generated at build time
 */

#define _GNU_SOURCE
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/uio.h>

#include "ipm_time.h"
#include "hashtable.h"
#include "perfdata.h"
#include "mod_posixio.h"
#include "ipm_core.h"

#ifdef HAVE_DYNLOAD
#include <execinfo.h>
#include <dlfcn.h>
#endif 

#ifdef HAVE_CALLPATH
#include "mod_callpath.h"
#endif

#ifdef HAVE_KEYHIST
#include "mod_keyhist.h"
#endif

#include <GEN.calltable_posixio.h>

#define MPI3CONST const




FILE* __real_fopen(MPI3CONST char *path, MPI3CONST char *mode);


/* ---- wrapping fopen ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         FILE*
 * CFNAME       fopen 
 * CPARAMS      MPI3CONST char *path, MPI3CONST char *mode
 * CARGS        path,mode
 * CARGFMT      '%s','%s'
 * CRETFMT      %p
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
FILE* fopen(MPI3CONST char *path, MPI3CONST char *mode)
#else
FILE* __wrap_fopen(MPI3CONST char *path, MPI3CONST char *mode)
#endif
{
  static int loaded=0;
  static FILE* (*fopen_real)(MPI3CONST char *path, MPI3CONST char *mode);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  FILE* rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    fopen_real=0;
    fopen_real=(FILE* (*)(MPI3CONST char *path, MPI3CONST char *mode)) dlsym(RTLD_NEXT, 
						      "fopen");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading fopen \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=fopen_real(path,mode);
#else
  rv=__real_fopen(path,mode); 
#endif
#else
#ifdef HAVE_DYNLOAD
  fopen_real(path,mode);
#else
  __real_fopen(path,mode); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %p %s('%s','%s') %u bytes %g sec\n", tstart, rv, "fopen", path,mode, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s('%s','%s') %u bytes %g sec\n", 
	    tstart, "fopen", path,mode, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_FOPEN_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




FILE* __real_fdopen(int fd, MPI3CONST char *mode);


/* ---- wrapping fdopen ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         FILE*
 * CFNAME       fdopen 
 * CPARAMS      int fd, MPI3CONST char *mode
 * CARGS        fd,mode
 * CARGFMT      %d,'%s'
 * CRETFMT      %p
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
FILE* fdopen(int fd, MPI3CONST char *mode)
#else
FILE* __wrap_fdopen(int fd, MPI3CONST char *mode)
#endif
{
  static int loaded=0;
  static FILE* (*fdopen_real)(int fd, MPI3CONST char *mode);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  FILE* rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    fdopen_real=0;
    fdopen_real=(FILE* (*)(int fd, MPI3CONST char *mode)) dlsym(RTLD_NEXT, 
						      "fdopen");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading fdopen \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=fdopen_real(fd,mode);
#else
  rv=__real_fdopen(fd,mode); 
#endif
#else
#ifdef HAVE_DYNLOAD
  fdopen_real(fd,mode);
#else
  __real_fdopen(fd,mode); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %p %s(%d,'%s') %u bytes %g sec\n", tstart, rv, "fdopen", fd,mode, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%d,'%s') %u bytes %g sec\n", 
	    tstart, "fdopen", fd,mode, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_FDOPEN_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




FILE* __real_freopen(MPI3CONST char *path, MPI3CONST char *mode, FILE *stream);


/* ---- wrapping freopen ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         FILE*
 * CFNAME       freopen 
 * CPARAMS      MPI3CONST char *path, MPI3CONST char *mode, FILE *stream
 * CARGS        path,mode,stream
 * CARGFMT      '%s','%s',%p
 * CRETFMT      %p
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
FILE* freopen(MPI3CONST char *path, MPI3CONST char *mode, FILE *stream)
#else
FILE* __wrap_freopen(MPI3CONST char *path, MPI3CONST char *mode, FILE *stream)
#endif
{
  static int loaded=0;
  static FILE* (*freopen_real)(MPI3CONST char *path, MPI3CONST char *mode, FILE *stream);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  FILE* rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    freopen_real=0;
    freopen_real=(FILE* (*)(MPI3CONST char *path, MPI3CONST char *mode, FILE *stream)) dlsym(RTLD_NEXT, 
						      "freopen");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading freopen \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=freopen_real(path,mode,stream);
#else
  rv=__real_freopen(path,mode,stream); 
#endif
#else
#ifdef HAVE_DYNLOAD
  freopen_real(path,mode,stream);
#else
  __real_freopen(path,mode,stream); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %p %s('%s','%s',%p) %u bytes %g sec\n", tstart, rv, "freopen", path,mode,stream, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s('%s','%s',%p) %u bytes %g sec\n", 
	    tstart, "freopen", path,mode,stream, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_FREOPEN_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




int __real_fclose(FILE *fp);


/* ---- wrapping fclose ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         int
 * CFNAME       fclose 
 * CPARAMS      FILE *fp
 * CARGS        fp
 * CARGFMT      %p
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
int fclose(FILE *fp)
#else
int __wrap_fclose(FILE *fp)
#endif
{
  static int loaded=0;
  static int (*fclose_real)(FILE *fp);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  int rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    fclose_real=0;
    fclose_real=(int (*)(FILE *fp)) dlsym(RTLD_NEXT, 
						      "fclose");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading fclose \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=fclose_real(fp);
#else
  rv=__real_fclose(fp); 
#endif
#else
#ifdef HAVE_DYNLOAD
  fclose_real(fp);
#else
  __real_fclose(fp); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%p) %u bytes %g sec\n", tstart, rv, "fclose", fp, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%p) %u bytes %g sec\n", 
	    tstart, "fclose", fp, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_FCLOSE_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




int __real_fflush(FILE *stream);


/* ---- wrapping fflush ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         int
 * CFNAME       fflush 
 * CPARAMS      FILE *stream
 * CARGS        stream
 * CARGFMT      %p
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
int fflush(FILE *stream)
#else
int __wrap_fflush(FILE *stream)
#endif
{
  static int loaded=0;
  static int (*fflush_real)(FILE *stream);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  int rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    fflush_real=0;
    fflush_real=(int (*)(FILE *stream)) dlsym(RTLD_NEXT, 
						      "fflush");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading fflush \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=fflush_real(stream);
#else
  rv=__real_fflush(stream); 
#endif
#else
#ifdef HAVE_DYNLOAD
  fflush_real(stream);
#else
  __real_fflush(stream); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%p) %u bytes %g sec\n", tstart, rv, "fflush", stream, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%p) %u bytes %g sec\n", 
	    tstart, "fflush", stream, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_FFLUSH_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




size_t __real_fread(void *ptr, size_t size, size_t nmemb, FILE *stream);


/* ---- wrapping fread ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         size_t
 * CFNAME       fread 
 * CPARAMS      void *ptr, size_t size, size_t nmemb, FILE *stream
 * CARGS        ptr,size,nmemb,stream
 * CARGFMT      %p,%d,%d,%p
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_RETURN_NMEMB_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
size_t fread(void *ptr, size_t size, size_t nmemb, FILE *stream)
#else
size_t __wrap_fread(void *ptr, size_t size, size_t nmemb, FILE *stream)
#endif
{
  static int loaded=0;
  static size_t (*fread_real)(void *ptr, size_t size, size_t nmemb, FILE *stream);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  size_t rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    fread_real=0;
    fread_real=(size_t (*)(void *ptr, size_t size, size_t nmemb, FILE *stream)) dlsym(RTLD_NEXT, 
						      "fread");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading fread \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=fread_real(ptr,size,nmemb,stream);
#else
  rv=__real_fread(ptr,size,nmemb,stream); 
#endif
#else
#ifdef HAVE_DYNLOAD
  fread_real(ptr,size,nmemb,stream);
#else
  __real_fread(ptr,size,nmemb,stream); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_RETURN_NMEMB_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%p,%d,%d,%p) %u bytes %g sec\n", tstart, rv, "fread", ptr,size,nmemb,stream, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%p,%d,%d,%p) %u bytes %g sec\n", 
	    tstart, "fread", ptr,size,nmemb,stream, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_FREAD_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




size_t __real_fwrite(MPI3CONST void *ptr, size_t size, size_t nmemb, FILE *stream);


/* ---- wrapping fwrite ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         size_t
 * CFNAME       fwrite 
 * CPARAMS      MPI3CONST void *ptr, size_t size, size_t nmemb, FILE *stream
 * CARGS        ptr,size,nmemb,stream
 * CARGFMT      %p,%d,%d,%p
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_RETURN_NMEMB_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
size_t fwrite(MPI3CONST void *ptr, size_t size, size_t nmemb, FILE *stream)
#else
size_t __wrap_fwrite(MPI3CONST void *ptr, size_t size, size_t nmemb, FILE *stream)
#endif
{
  static int loaded=0;
  static size_t (*fwrite_real)(MPI3CONST void *ptr, size_t size, size_t nmemb, FILE *stream);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  size_t rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    fwrite_real=0;
    fwrite_real=(size_t (*)(MPI3CONST void *ptr, size_t size, size_t nmemb, FILE *stream)) dlsym(RTLD_NEXT, 
						      "fwrite");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading fwrite \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=fwrite_real(ptr,size,nmemb,stream);
#else
  rv=__real_fwrite(ptr,size,nmemb,stream); 
#endif
#else
#ifdef HAVE_DYNLOAD
  fwrite_real(ptr,size,nmemb,stream);
#else
  __real_fwrite(ptr,size,nmemb,stream); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_RETURN_NMEMB_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%p,%d,%d,%p) %u bytes %g sec\n", tstart, rv, "fwrite", ptr,size,nmemb,stream, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%p,%d,%d,%p) %u bytes %g sec\n", 
	    tstart, "fwrite", ptr,size,nmemb,stream, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_FWRITE_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




int __real_fseek(FILE *stream, long offset, int whence);


/* ---- wrapping fseek ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         int
 * CFNAME       fseek 
 * CPARAMS      FILE *stream, long offset, int whence
 * CARGS        stream,offset,whence
 * CARGFMT      %p,%d,%d
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
int fseek(FILE *stream, long offset, int whence)
#else
int __wrap_fseek(FILE *stream, long offset, int whence)
#endif
{
  static int loaded=0;
  static int (*fseek_real)(FILE *stream, long offset, int whence);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  int rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    fseek_real=0;
    fseek_real=(int (*)(FILE *stream, long offset, int whence)) dlsym(RTLD_NEXT, 
						      "fseek");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading fseek \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=fseek_real(stream,offset,whence);
#else
  rv=__real_fseek(stream,offset,whence); 
#endif
#else
#ifdef HAVE_DYNLOAD
  fseek_real(stream,offset,whence);
#else
  __real_fseek(stream,offset,whence); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%p,%d,%d) %u bytes %g sec\n", tstart, rv, "fseek", stream,offset,whence, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%p,%d,%d) %u bytes %g sec\n", 
	    tstart, "fseek", stream,offset,whence, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_FSEEK_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




long __real_ftell(FILE *stream);


/* ---- wrapping ftell ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         long
 * CFNAME       ftell 
 * CPARAMS      FILE *stream
 * CARGS        stream
 * CARGFMT      %p
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
long ftell(FILE *stream)
#else
long __wrap_ftell(FILE *stream)
#endif
{
  static int loaded=0;
  static long (*ftell_real)(FILE *stream);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  long rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    ftell_real=0;
    ftell_real=(long (*)(FILE *stream)) dlsym(RTLD_NEXT, 
						      "ftell");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading ftell \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=ftell_real(stream);
#else
  rv=__real_ftell(stream); 
#endif
#else
#ifdef HAVE_DYNLOAD
  ftell_real(stream);
#else
  __real_ftell(stream); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%p) %u bytes %g sec\n", tstart, rv, "ftell", stream, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%p) %u bytes %g sec\n", 
	    tstart, "ftell", stream, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_FTELL_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




void __real_rewind(FILE *stream);


/* ---- wrapping rewind ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         void
 * CFNAME       rewind 
 * CPARAMS      FILE *stream
 * CARGS        stream
 * CARGFMT      %p
 * CRETFMT      
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 0
 */

#ifdef HAVE_DYNLOAD
void rewind(FILE *stream)
#else
void __wrap_rewind(FILE *stream)
#endif
{
  static int loaded=0;
  static void (*rewind_real)(FILE *stream);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 0
  void rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    rewind_real=0;
    rewind_real=(void (*)(FILE *stream)) dlsym(RTLD_NEXT, 
						      "rewind");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading rewind \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 0
#ifdef HAVE_DYNLOAD
  rv=rewind_real(stream);
#else
  rv=__real_rewind(stream); 
#endif
#else
#ifdef HAVE_DYNLOAD
  rewind_real(stream);
#else
  __real_rewind(stream); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 0
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 0
    fprintf(task.tracefile, "%10.6f  %s(%p) %u bytes %g sec\n", tstart, rv, "rewind", stream, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%p) %u bytes %g sec\n", 
	    tstart, "rewind", stream, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_REWIND_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 0
    return rv;
#else
    return;
#endif
}




int __real_fgetpos(FILE *stream, fpos_t *pos);


/* ---- wrapping fgetpos ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         int
 * CFNAME       fgetpos 
 * CPARAMS      FILE *stream, fpos_t *pos
 * CARGS        stream,pos
 * CARGFMT      %p,%p
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
int fgetpos(FILE *stream, fpos_t *pos)
#else
int __wrap_fgetpos(FILE *stream, fpos_t *pos)
#endif
{
  static int loaded=0;
  static int (*fgetpos_real)(FILE *stream, fpos_t *pos);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  int rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    fgetpos_real=0;
    fgetpos_real=(int (*)(FILE *stream, fpos_t *pos)) dlsym(RTLD_NEXT, 
						      "fgetpos");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading fgetpos \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=fgetpos_real(stream,pos);
#else
  rv=__real_fgetpos(stream,pos); 
#endif
#else
#ifdef HAVE_DYNLOAD
  fgetpos_real(stream,pos);
#else
  __real_fgetpos(stream,pos); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%p,%p) %u bytes %g sec\n", tstart, rv, "fgetpos", stream,pos, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%p,%p) %u bytes %g sec\n", 
	    tstart, "fgetpos", stream,pos, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_FGETPOS_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




int __real_fsetpos(FILE *stream, MPI3CONST fpos_t *pos);


/* ---- wrapping fsetpos ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         int
 * CFNAME       fsetpos 
 * CPARAMS      FILE *stream, MPI3CONST fpos_t *pos
 * CARGS        stream,pos
 * CARGFMT      %p,%p
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
int fsetpos(FILE *stream, MPI3CONST fpos_t *pos)
#else
int __wrap_fsetpos(FILE *stream, MPI3CONST fpos_t *pos)
#endif
{
  static int loaded=0;
  static int (*fsetpos_real)(FILE *stream, MPI3CONST fpos_t *pos);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  int rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    fsetpos_real=0;
    fsetpos_real=(int (*)(FILE *stream, MPI3CONST fpos_t *pos)) dlsym(RTLD_NEXT, 
						      "fsetpos");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading fsetpos \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=fsetpos_real(stream,pos);
#else
  rv=__real_fsetpos(stream,pos); 
#endif
#else
#ifdef HAVE_DYNLOAD
  fsetpos_real(stream,pos);
#else
  __real_fsetpos(stream,pos); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%p,%p) %u bytes %g sec\n", tstart, rv, "fsetpos", stream,pos, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%p,%p) %u bytes %g sec\n", 
	    tstart, "fsetpos", stream,pos, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_FSETPOS_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




int __real_fgetc(FILE *stream);


/* ---- wrapping fgetc ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         int
 * CFNAME       fgetc 
 * CPARAMS      FILE *stream
 * CARGS        stream
 * CARGFMT      %p
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_RETURN_EOF_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
int fgetc(FILE *stream)
#else
int __wrap_fgetc(FILE *stream)
#endif
{
  static int loaded=0;
  static int (*fgetc_real)(FILE *stream);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  int rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    fgetc_real=0;
    fgetc_real=(int (*)(FILE *stream)) dlsym(RTLD_NEXT, 
						      "fgetc");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading fgetc \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=fgetc_real(stream);
#else
  rv=__real_fgetc(stream); 
#endif
#else
#ifdef HAVE_DYNLOAD
  fgetc_real(stream);
#else
  __real_fgetc(stream); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_RETURN_EOF_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%p) %u bytes %g sec\n", tstart, rv, "fgetc", stream, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%p) %u bytes %g sec\n", 
	    tstart, "fgetc", stream, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_FGETC_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




int __real_getc(FILE *stream);


/* ---- wrapping getc ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         int
 * CFNAME       getc 
 * CPARAMS      FILE *stream
 * CARGS        stream
 * CARGFMT      %p
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_RETURN_EOF_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
int getc(FILE *stream)
#else
int __wrap_getc(FILE *stream)
#endif
{
  static int loaded=0;
  static int (*getc_real)(FILE *stream);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  int rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    getc_real=0;
    getc_real=(int (*)(FILE *stream)) dlsym(RTLD_NEXT, 
						      "getc");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading getc \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=getc_real(stream);
#else
  rv=__real_getc(stream); 
#endif
#else
#ifdef HAVE_DYNLOAD
  getc_real(stream);
#else
  __real_getc(stream); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_RETURN_EOF_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%p) %u bytes %g sec\n", tstart, rv, "getc", stream, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%p) %u bytes %g sec\n", 
	    tstart, "getc", stream, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_GETC_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




int __real_ungetc(int c, FILE *stream);


/* ---- wrapping ungetc ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         int
 * CFNAME       ungetc 
 * CPARAMS      int c, FILE *stream
 * CARGS        c,stream
 * CARGFMT      %d,%p
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_RETURN_EOF_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
int ungetc(int c, FILE *stream)
#else
int __wrap_ungetc(int c, FILE *stream)
#endif
{
  static int loaded=0;
  static int (*ungetc_real)(int c, FILE *stream);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  int rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    ungetc_real=0;
    ungetc_real=(int (*)(int c, FILE *stream)) dlsym(RTLD_NEXT, 
						      "ungetc");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading ungetc \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=ungetc_real(c,stream);
#else
  rv=__real_ungetc(c,stream); 
#endif
#else
#ifdef HAVE_DYNLOAD
  ungetc_real(c,stream);
#else
  __real_ungetc(c,stream); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_RETURN_EOF_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%d,%p) %u bytes %g sec\n", tstart, rv, "ungetc", c,stream, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%d,%p) %u bytes %g sec\n", 
	    tstart, "ungetc", c,stream, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_UNGETC_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




ssize_t __real_read(int fd, void *buf, size_t count);


/* ---- wrapping read ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         ssize_t
 * CFNAME       read 
 * CPARAMS      int fd, void *buf, size_t count
 * CARGS        fd,buf,count
 * CARGFMT      %d,%p,%d
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_RETURN_COUNT_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
ssize_t read(int fd, void *buf, size_t count)
#else
ssize_t __wrap_read(int fd, void *buf, size_t count)
#endif
{
  static int loaded=0;
  static ssize_t (*read_real)(int fd, void *buf, size_t count);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  ssize_t rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    read_real=0;
    read_real=(ssize_t (*)(int fd, void *buf, size_t count)) dlsym(RTLD_NEXT, 
						      "read");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading read \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=read_real(fd,buf,count);
#else
  rv=__real_read(fd,buf,count); 
#endif
#else
#ifdef HAVE_DYNLOAD
  read_real(fd,buf,count);
#else
  __real_read(fd,buf,count); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_RETURN_COUNT_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%d,%p,%d) %u bytes %g sec\n", tstart, rv, "read", fd,buf,count, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%d,%p,%d) %u bytes %g sec\n", 
	    tstart, "read", fd,buf,count, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_READ_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




ssize_t __real_write(int fd, MPI3CONST void *buf, size_t count);


/* ---- wrapping write ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         ssize_t
 * CFNAME       write 
 * CPARAMS      int fd, MPI3CONST void *buf, size_t count
 * CARGS        fd,buf,count
 * CARGFMT      %d,%p,%d
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_RETURN_COUNT_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
ssize_t write(int fd, MPI3CONST void *buf, size_t count)
#else
ssize_t __wrap_write(int fd, MPI3CONST void *buf, size_t count)
#endif
{
  static int loaded=0;
  static ssize_t (*write_real)(int fd, MPI3CONST void *buf, size_t count);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  ssize_t rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    write_real=0;
    write_real=(ssize_t (*)(int fd, MPI3CONST void *buf, size_t count)) dlsym(RTLD_NEXT, 
						      "write");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading write \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=write_real(fd,buf,count);
#else
  rv=__real_write(fd,buf,count); 
#endif
#else
#ifdef HAVE_DYNLOAD
  write_real(fd,buf,count);
#else
  __real_write(fd,buf,count); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_RETURN_COUNT_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%d,%p,%d) %u bytes %g sec\n", tstart, rv, "write", fd,buf,count, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%d,%p,%d) %u bytes %g sec\n", 
	    tstart, "write", fd,buf,count, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_WRITE_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




int __real_open(MPI3CONST char *pathname, int flags, mode_t mode);


/* ---- wrapping open ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         int
 * CFNAME       open 
 * CPARAMS      MPI3CONST char *pathname, int flags, mode_t mode
 * CARGS        pathname,flags,mode
 * CARGFMT      '%s',%d,%d
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
int open(MPI3CONST char *pathname, int flags, mode_t mode)
#else
int __wrap_open(MPI3CONST char *pathname, int flags, mode_t mode)
#endif
{
  static int loaded=0;
  static int (*open_real)(MPI3CONST char *pathname, int flags, mode_t mode);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  int rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    open_real=0;
    open_real=(int (*)(MPI3CONST char *pathname, int flags, mode_t mode)) dlsym(RTLD_NEXT, 
						      "open");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading open \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=open_real(pathname,flags,mode);
#else
  rv=__real_open(pathname,flags,mode); 
#endif
#else
#ifdef HAVE_DYNLOAD
  open_real(pathname,flags,mode);
#else
  __real_open(pathname,flags,mode); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s('%s',%d,%d) %u bytes %g sec\n", tstart, rv, "open", pathname,flags,mode, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s('%s',%d,%d) %u bytes %g sec\n", 
	    tstart, "open", pathname,flags,mode, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_OPEN_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




int __real_open64(MPI3CONST char *pathname, int flags, mode_t mode);


/* ---- wrapping open64 ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         int
 * CFNAME       open64 
 * CPARAMS      MPI3CONST char *pathname, int flags, mode_t mode
 * CARGS        pathname,flags,mode
 * CARGFMT      '%s',%d,%d
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
int open64(MPI3CONST char *pathname, int flags, mode_t mode)
#else
int __wrap_open64(MPI3CONST char *pathname, int flags, mode_t mode)
#endif
{
  static int loaded=0;
  static int (*open64_real)(MPI3CONST char *pathname, int flags, mode_t mode);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  int rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    open64_real=0;
    open64_real=(int (*)(MPI3CONST char *pathname, int flags, mode_t mode)) dlsym(RTLD_NEXT, 
						      "open64");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading open64 \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=open64_real(pathname,flags,mode);
#else
  rv=__real_open64(pathname,flags,mode); 
#endif
#else
#ifdef HAVE_DYNLOAD
  open64_real(pathname,flags,mode);
#else
  __real_open64(pathname,flags,mode); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s('%s',%d,%d) %u bytes %g sec\n", tstart, rv, "open64", pathname,flags,mode, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s('%s',%d,%d) %u bytes %g sec\n", 
	    tstart, "open64", pathname,flags,mode, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_OPEN64_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




int __real_creat(MPI3CONST char *pathname, mode_t mode);


/* ---- wrapping creat ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         int
 * CFNAME       creat 
 * CPARAMS      MPI3CONST char *pathname, mode_t mode
 * CARGS        pathname,mode
 * CARGFMT      '%s',%d
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
int creat(MPI3CONST char *pathname, mode_t mode)
#else
int __wrap_creat(MPI3CONST char *pathname, mode_t mode)
#endif
{
  static int loaded=0;
  static int (*creat_real)(MPI3CONST char *pathname, mode_t mode);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  int rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    creat_real=0;
    creat_real=(int (*)(MPI3CONST char *pathname, mode_t mode)) dlsym(RTLD_NEXT, 
						      "creat");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading creat \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=creat_real(pathname,mode);
#else
  rv=__real_creat(pathname,mode); 
#endif
#else
#ifdef HAVE_DYNLOAD
  creat_real(pathname,mode);
#else
  __real_creat(pathname,mode); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s('%s',%d) %u bytes %g sec\n", tstart, rv, "creat", pathname,mode, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s('%s',%d) %u bytes %g sec\n", 
	    tstart, "creat", pathname,mode, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_CREAT_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




int __real_close(int fd);


/* ---- wrapping close ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         int
 * CFNAME       close 
 * CPARAMS      int fd
 * CARGS        fd
 * CARGFMT      %d
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
int close(int fd)
#else
int __wrap_close(int fd)
#endif
{
  static int loaded=0;
  static int (*close_real)(int fd);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  int rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    close_real=0;
    close_real=(int (*)(int fd)) dlsym(RTLD_NEXT, 
						      "close");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading close \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=close_real(fd);
#else
  rv=__real_close(fd); 
#endif
#else
#ifdef HAVE_DYNLOAD
  close_real(fd);
#else
  __real_close(fd); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%d) %u bytes %g sec\n", tstart, rv, "close", fd, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%d) %u bytes %g sec\n", 
	    tstart, "close", fd, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_CLOSE_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




int __real_truncate(MPI3CONST char *path, off_t length);


/* ---- wrapping truncate ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         int
 * CFNAME       truncate 
 * CPARAMS      MPI3CONST char *path, off_t length
 * CARGS        path,length
 * CARGFMT      '%s',%d
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
int truncate(MPI3CONST char *path, off_t length)
#else
int __wrap_truncate(MPI3CONST char *path, off_t length)
#endif
{
  static int loaded=0;
  static int (*truncate_real)(MPI3CONST char *path, off_t length);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  int rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    truncate_real=0;
    truncate_real=(int (*)(MPI3CONST char *path, off_t length)) dlsym(RTLD_NEXT, 
						      "truncate");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading truncate \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=truncate_real(path,length);
#else
  rv=__real_truncate(path,length); 
#endif
#else
#ifdef HAVE_DYNLOAD
  truncate_real(path,length);
#else
  __real_truncate(path,length); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s('%s',%d) %u bytes %g sec\n", tstart, rv, "truncate", path,length, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s('%s',%d) %u bytes %g sec\n", 
	    tstart, "truncate", path,length, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_TRUNCATE_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




int __real_ftruncate(int fd, off_t length);


/* ---- wrapping ftruncate ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         int
 * CFNAME       ftruncate 
 * CPARAMS      int fd, off_t length
 * CARGS        fd,length
 * CARGFMT      %d,%d
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
int ftruncate(int fd, off_t length)
#else
int __wrap_ftruncate(int fd, off_t length)
#endif
{
  static int loaded=0;
  static int (*ftruncate_real)(int fd, off_t length);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  int rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    ftruncate_real=0;
    ftruncate_real=(int (*)(int fd, off_t length)) dlsym(RTLD_NEXT, 
						      "ftruncate");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading ftruncate \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=ftruncate_real(fd,length);
#else
  rv=__real_ftruncate(fd,length); 
#endif
#else
#ifdef HAVE_DYNLOAD
  ftruncate_real(fd,length);
#else
  __real_ftruncate(fd,length); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%d,%d) %u bytes %g sec\n", tstart, rv, "ftruncate", fd,length, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%d,%d) %u bytes %g sec\n", 
	    tstart, "ftruncate", fd,length, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_FTRUNCATE_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




int __real_truncate64(MPI3CONST char *path, off64_t length);


/* ---- wrapping truncate64 ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         int
 * CFNAME       truncate64 
 * CPARAMS      MPI3CONST char *path, off64_t length
 * CARGS        path,length
 * CARGFMT      '%s',%l
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
int truncate64(MPI3CONST char *path, off64_t length)
#else
int __wrap_truncate64(MPI3CONST char *path, off64_t length)
#endif
{
  static int loaded=0;
  static int (*truncate64_real)(MPI3CONST char *path, off64_t length);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  int rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    truncate64_real=0;
    truncate64_real=(int (*)(MPI3CONST char *path, off64_t length)) dlsym(RTLD_NEXT, 
						      "truncate64");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading truncate64 \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=truncate64_real(path,length);
#else
  rv=__real_truncate64(path,length); 
#endif
#else
#ifdef HAVE_DYNLOAD
  truncate64_real(path,length);
#else
  __real_truncate64(path,length); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s('%s',%l) %u bytes %g sec\n", tstart, rv, "truncate64", path,length, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s('%s',%l) %u bytes %g sec\n", 
	    tstart, "truncate64", path,length, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_TRUNCATE64_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




int __real_ftruncate64(int fd, off64_t length);


/* ---- wrapping ftruncate64 ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         int
 * CFNAME       ftruncate64 
 * CPARAMS      int fd, off64_t length
 * CARGS        fd,length
 * CARGFMT      %d,%l
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
int ftruncate64(int fd, off64_t length)
#else
int __wrap_ftruncate64(int fd, off64_t length)
#endif
{
  static int loaded=0;
  static int (*ftruncate64_real)(int fd, off64_t length);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  int rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    ftruncate64_real=0;
    ftruncate64_real=(int (*)(int fd, off64_t length)) dlsym(RTLD_NEXT, 
						      "ftruncate64");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading ftruncate64 \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=ftruncate64_real(fd,length);
#else
  rv=__real_ftruncate64(fd,length); 
#endif
#else
#ifdef HAVE_DYNLOAD
  ftruncate64_real(fd,length);
#else
  __real_ftruncate64(fd,length); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%d,%l) %u bytes %g sec\n", tstart, rv, "ftruncate64", fd,length, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%d,%l) %u bytes %g sec\n", 
	    tstart, "ftruncate64", fd,length, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_FTRUNCATE64_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




off_t __real_lseek(int fd, off_t offset, int whence);


/* ---- wrapping lseek ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         off_t
 * CFNAME       lseek 
 * CPARAMS      int fd, off_t offset, int whence
 * CARGS        fd,offset,whence
 * CARGFMT      %d,%d,%d
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
off_t lseek(int fd, off_t offset, int whence)
#else
off_t __wrap_lseek(int fd, off_t offset, int whence)
#endif
{
  static int loaded=0;
  static off_t (*lseek_real)(int fd, off_t offset, int whence);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  off_t rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    lseek_real=0;
    lseek_real=(off_t (*)(int fd, off_t offset, int whence)) dlsym(RTLD_NEXT, 
						      "lseek");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading lseek \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=lseek_real(fd,offset,whence);
#else
  rv=__real_lseek(fd,offset,whence); 
#endif
#else
#ifdef HAVE_DYNLOAD
  lseek_real(fd,offset,whence);
#else
  __real_lseek(fd,offset,whence); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%d,%d,%d) %u bytes %g sec\n", tstart, rv, "lseek", fd,offset,whence, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%d,%d,%d) %u bytes %g sec\n", 
	    tstart, "lseek", fd,offset,whence, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_LSEEK_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




off64_t __real_lseek64(int fd, off64_t offset, int whence);


/* ---- wrapping lseek64 ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         off64_t
 * CFNAME       lseek64 
 * CPARAMS      int fd, off64_t offset, int whence
 * CARGS        fd,offset,whence
 * CARGFMT      %d,%l,%d
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
off64_t lseek64(int fd, off64_t offset, int whence)
#else
off64_t __wrap_lseek64(int fd, off64_t offset, int whence)
#endif
{
  static int loaded=0;
  static off64_t (*lseek64_real)(int fd, off64_t offset, int whence);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  off64_t rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    lseek64_real=0;
    lseek64_real=(off64_t (*)(int fd, off64_t offset, int whence)) dlsym(RTLD_NEXT, 
						      "lseek64");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading lseek64 \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=lseek64_real(fd,offset,whence);
#else
  rv=__real_lseek64(fd,offset,whence); 
#endif
#else
#ifdef HAVE_DYNLOAD
  lseek64_real(fd,offset,whence);
#else
  __real_lseek64(fd,offset,whence); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%d,%l,%d) %u bytes %g sec\n", tstart, rv, "lseek64", fd,offset,whence, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%d,%l,%d) %u bytes %g sec\n", 
	    tstart, "lseek64", fd,offset,whence, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_LSEEK64_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




int __real_fsync(int fd);


/* ---- wrapping fsync ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         int
 * CFNAME       fsync 
 * CPARAMS      int fd
 * CARGS        fd
 * CARGFMT      %d
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
int fsync(int fd)
#else
int __wrap_fsync(int fd)
#endif
{
  static int loaded=0;
  static int (*fsync_real)(int fd);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  int rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    fsync_real=0;
    fsync_real=(int (*)(int fd)) dlsym(RTLD_NEXT, 
						      "fsync");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading fsync \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=fsync_real(fd);
#else
  rv=__real_fsync(fd); 
#endif
#else
#ifdef HAVE_DYNLOAD
  fsync_real(fd);
#else
  __real_fsync(fd); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%d) %u bytes %g sec\n", tstart, rv, "fsync", fd, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%d) %u bytes %g sec\n", 
	    tstart, "fsync", fd, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_FSYNC_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




int __real_fdatasync(int fd);


/* ---- wrapping fdatasync ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         int
 * CFNAME       fdatasync 
 * CPARAMS      int fd
 * CARGS        fd
 * CARGFMT      %d
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
int fdatasync(int fd)
#else
int __wrap_fdatasync(int fd)
#endif
{
  static int loaded=0;
  static int (*fdatasync_real)(int fd);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  int rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    fdatasync_real=0;
    fdatasync_real=(int (*)(int fd)) dlsym(RTLD_NEXT, 
						      "fdatasync");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading fdatasync \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=fdatasync_real(fd);
#else
  rv=__real_fdatasync(fd); 
#endif
#else
#ifdef HAVE_DYNLOAD
  fdatasync_real(fd);
#else
  __real_fdatasync(fd); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%d) %u bytes %g sec\n", tstart, rv, "fdatasync", fd, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%d) %u bytes %g sec\n", 
	    tstart, "fdatasync", fd, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_FDATASYNC_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




FILE* __real_fopen64(MPI3CONST char *path, MPI3CONST char *mode);


/* ---- wrapping fopen64 ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         FILE*
 * CFNAME       fopen64 
 * CPARAMS      MPI3CONST char *path, MPI3CONST char *mode
 * CARGS        path,mode
 * CARGFMT      '%s','%s'
 * CRETFMT      %p
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
FILE* fopen64(MPI3CONST char *path, MPI3CONST char *mode)
#else
FILE* __wrap_fopen64(MPI3CONST char *path, MPI3CONST char *mode)
#endif
{
  static int loaded=0;
  static FILE* (*fopen64_real)(MPI3CONST char *path, MPI3CONST char *mode);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  FILE* rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    fopen64_real=0;
    fopen64_real=(FILE* (*)(MPI3CONST char *path, MPI3CONST char *mode)) dlsym(RTLD_NEXT, 
						      "fopen64");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading fopen64 \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=fopen64_real(path,mode);
#else
  rv=__real_fopen64(path,mode); 
#endif
#else
#ifdef HAVE_DYNLOAD
  fopen64_real(path,mode);
#else
  __real_fopen64(path,mode); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %p %s('%s','%s') %u bytes %g sec\n", tstart, rv, "fopen64", path,mode, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s('%s','%s') %u bytes %g sec\n", 
	    tstart, "fopen64", path,mode, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_FOPEN64_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




FILE* __real_freopen64(MPI3CONST char *path, MPI3CONST char *mode, FILE *stream);


/* ---- wrapping freopen64 ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         FILE*
 * CFNAME       freopen64 
 * CPARAMS      MPI3CONST char *path, MPI3CONST char *mode, FILE *stream
 * CARGS        path,mode,stream
 * CARGFMT      '%s','%s',%p
 * CRETFMT      %p
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
FILE* freopen64(MPI3CONST char *path, MPI3CONST char *mode, FILE *stream)
#else
FILE* __wrap_freopen64(MPI3CONST char *path, MPI3CONST char *mode, FILE *stream)
#endif
{
  static int loaded=0;
  static FILE* (*freopen64_real)(MPI3CONST char *path, MPI3CONST char *mode, FILE *stream);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  FILE* rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    freopen64_real=0;
    freopen64_real=(FILE* (*)(MPI3CONST char *path, MPI3CONST char *mode, FILE *stream)) dlsym(RTLD_NEXT, 
						      "freopen64");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading freopen64 \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=freopen64_real(path,mode,stream);
#else
  rv=__real_freopen64(path,mode,stream); 
#endif
#else
#ifdef HAVE_DYNLOAD
  freopen64_real(path,mode,stream);
#else
  __real_freopen64(path,mode,stream); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %p %s('%s','%s',%p) %u bytes %g sec\n", tstart, rv, "freopen64", path,mode,stream, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s('%s','%s',%p) %u bytes %g sec\n", 
	    tstart, "freopen64", path,mode,stream, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_FREOPEN64_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




int __real___xstat(int ver, MPI3CONST char *path, struct stat *buf);


/* ---- wrapping __xstat ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         int
 * CFNAME       __xstat 
 * CPARAMS      int ver, MPI3CONST char *path, struct stat *buf
 * CARGS        ver,path,buf
 * CARGFMT      %d,'%s',%p
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
int __xstat(int ver, MPI3CONST char *path, struct stat *buf)
#else
int __wrap___xstat(int ver, MPI3CONST char *path, struct stat *buf)
#endif
{
  static int loaded=0;
  static int (*__xstat_real)(int ver, MPI3CONST char *path, struct stat *buf);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  int rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    __xstat_real=0;
    __xstat_real=(int (*)(int ver, MPI3CONST char *path, struct stat *buf)) dlsym(RTLD_NEXT, 
						      "__xstat");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading __xstat \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=__xstat_real(ver,path,buf);
#else
  rv=__real___xstat(ver,path,buf); 
#endif
#else
#ifdef HAVE_DYNLOAD
  __xstat_real(ver,path,buf);
#else
  __real___xstat(ver,path,buf); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%d,'%s',%p) %u bytes %g sec\n", tstart, rv, "__xstat", ver,path,buf, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%d,'%s',%p) %u bytes %g sec\n", 
	    tstart, "__xstat", ver,path,buf, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO___XSTAT_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




int __real___xstat64(int ver, MPI3CONST char *path, struct stat64 *buf);


/* ---- wrapping __xstat64 ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         int
 * CFNAME       __xstat64 
 * CPARAMS      int ver, MPI3CONST char *path, struct stat64 *buf
 * CARGS        ver,path,buf
 * CARGFMT      %d,'%s',%p
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
int __xstat64(int ver, MPI3CONST char *path, struct stat64 *buf)
#else
int __wrap___xstat64(int ver, MPI3CONST char *path, struct stat64 *buf)
#endif
{
  static int loaded=0;
  static int (*__xstat64_real)(int ver, MPI3CONST char *path, struct stat64 *buf);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  int rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    __xstat64_real=0;
    __xstat64_real=(int (*)(int ver, MPI3CONST char *path, struct stat64 *buf)) dlsym(RTLD_NEXT, 
						      "__xstat64");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading __xstat64 \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=__xstat64_real(ver,path,buf);
#else
  rv=__real___xstat64(ver,path,buf); 
#endif
#else
#ifdef HAVE_DYNLOAD
  __xstat64_real(ver,path,buf);
#else
  __real___xstat64(ver,path,buf); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%d,'%s',%p) %u bytes %g sec\n", tstart, rv, "__xstat64", ver,path,buf, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%d,'%s',%p) %u bytes %g sec\n", 
	    tstart, "__xstat64", ver,path,buf, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO___XSTAT64_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




int __real___lxstat(int ver, MPI3CONST char *path, struct stat *buf);


/* ---- wrapping __lxstat ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         int
 * CFNAME       __lxstat 
 * CPARAMS      int ver, MPI3CONST char *path, struct stat *buf
 * CARGS        ver,path,buf
 * CARGFMT      %d,'%s',%p
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
int __lxstat(int ver, MPI3CONST char *path, struct stat *buf)
#else
int __wrap___lxstat(int ver, MPI3CONST char *path, struct stat *buf)
#endif
{
  static int loaded=0;
  static int (*__lxstat_real)(int ver, MPI3CONST char *path, struct stat *buf);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  int rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    __lxstat_real=0;
    __lxstat_real=(int (*)(int ver, MPI3CONST char *path, struct stat *buf)) dlsym(RTLD_NEXT, 
						      "__lxstat");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading __lxstat \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=__lxstat_real(ver,path,buf);
#else
  rv=__real___lxstat(ver,path,buf); 
#endif
#else
#ifdef HAVE_DYNLOAD
  __lxstat_real(ver,path,buf);
#else
  __real___lxstat(ver,path,buf); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%d,'%s',%p) %u bytes %g sec\n", tstart, rv, "__lxstat", ver,path,buf, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%d,'%s',%p) %u bytes %g sec\n", 
	    tstart, "__lxstat", ver,path,buf, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO___LXSTAT_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




int __real___lxstat64(int ver, MPI3CONST char *path, struct stat64 *buf);


/* ---- wrapping __lxstat64 ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         int
 * CFNAME       __lxstat64 
 * CPARAMS      int ver, MPI3CONST char *path, struct stat64 *buf
 * CARGS        ver,path,buf
 * CARGFMT      %d,'%s',%p
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
int __lxstat64(int ver, MPI3CONST char *path, struct stat64 *buf)
#else
int __wrap___lxstat64(int ver, MPI3CONST char *path, struct stat64 *buf)
#endif
{
  static int loaded=0;
  static int (*__lxstat64_real)(int ver, MPI3CONST char *path, struct stat64 *buf);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  int rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    __lxstat64_real=0;
    __lxstat64_real=(int (*)(int ver, MPI3CONST char *path, struct stat64 *buf)) dlsym(RTLD_NEXT, 
						      "__lxstat64");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading __lxstat64 \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=__lxstat64_real(ver,path,buf);
#else
  rv=__real___lxstat64(ver,path,buf); 
#endif
#else
#ifdef HAVE_DYNLOAD
  __lxstat64_real(ver,path,buf);
#else
  __real___lxstat64(ver,path,buf); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%d,'%s',%p) %u bytes %g sec\n", tstart, rv, "__lxstat64", ver,path,buf, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%d,'%s',%p) %u bytes %g sec\n", 
	    tstart, "__lxstat64", ver,path,buf, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO___LXSTAT64_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




int __real___fxstat(int ver, int fd, struct stat *buf);


/* ---- wrapping __fxstat ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         int
 * CFNAME       __fxstat 
 * CPARAMS      int ver, int fd, struct stat *buf
 * CARGS        ver,fd,buf
 * CARGFMT      %d,%d,%p
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
int __fxstat(int ver, int fd, struct stat *buf)
#else
int __wrap___fxstat(int ver, int fd, struct stat *buf)
#endif
{
  static int loaded=0;
  static int (*__fxstat_real)(int ver, int fd, struct stat *buf);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  int rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    __fxstat_real=0;
    __fxstat_real=(int (*)(int ver, int fd, struct stat *buf)) dlsym(RTLD_NEXT, 
						      "__fxstat");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading __fxstat \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=__fxstat_real(ver,fd,buf);
#else
  rv=__real___fxstat(ver,fd,buf); 
#endif
#else
#ifdef HAVE_DYNLOAD
  __fxstat_real(ver,fd,buf);
#else
  __real___fxstat(ver,fd,buf); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%d,%d,%p) %u bytes %g sec\n", tstart, rv, "__fxstat", ver,fd,buf, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%d,%d,%p) %u bytes %g sec\n", 
	    tstart, "__fxstat", ver,fd,buf, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO___FXSTAT_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




int __real___fxstat64(int ver, int fd, struct stat64 *buf);


/* ---- wrapping __fxstat64 ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         int
 * CFNAME       __fxstat64 
 * CPARAMS      int ver, int fd, struct stat64 *buf
 * CARGS        ver,fd,buf
 * CARGFMT      %d,%d,%p
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
int __fxstat64(int ver, int fd, struct stat64 *buf)
#else
int __wrap___fxstat64(int ver, int fd, struct stat64 *buf)
#endif
{
  static int loaded=0;
  static int (*__fxstat64_real)(int ver, int fd, struct stat64 *buf);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  int rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    __fxstat64_real=0;
    __fxstat64_real=(int (*)(int ver, int fd, struct stat64 *buf)) dlsym(RTLD_NEXT, 
						      "__fxstat64");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading __fxstat64 \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=__fxstat64_real(ver,fd,buf);
#else
  rv=__real___fxstat64(ver,fd,buf); 
#endif
#else
#ifdef HAVE_DYNLOAD
  __fxstat64_real(ver,fd,buf);
#else
  __real___fxstat64(ver,fd,buf); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%d,%d,%p) %u bytes %g sec\n", tstart, rv, "__fxstat64", ver,fd,buf, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%d,%d,%p) %u bytes %g sec\n", 
	    tstart, "__fxstat64", ver,fd,buf, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO___FXSTAT64_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




char* __real_fgets(char *s, int size, FILE *stream);


/* ---- wrapping fgets ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         char*
 * CFNAME       fgets 
 * CPARAMS      char *s, int size, FILE *stream
 * CARGS        s,size,stream
 * CARGFMT      %p,%d,%p
 * CRETFMT      %p
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_RETURN_NULL_STR_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
char* fgets(char *s, int size, FILE *stream)
#else
char* __wrap_fgets(char *s, int size, FILE *stream)
#endif
{
  static int loaded=0;
  static char* (*fgets_real)(char *s, int size, FILE *stream);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  char* rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    fgets_real=0;
    fgets_real=(char* (*)(char *s, int size, FILE *stream)) dlsym(RTLD_NEXT, 
						      "fgets");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading fgets \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=fgets_real(s,size,stream);
#else
  rv=__real_fgets(s,size,stream); 
#endif
#else
#ifdef HAVE_DYNLOAD
  fgets_real(s,size,stream);
#else
  __real_fgets(s,size,stream); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_RETURN_NULL_STR_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %p %s(%p,%d,%p) %u bytes %g sec\n", tstart, rv, "fgets", s,size,stream, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%p,%d,%p) %u bytes %g sec\n", 
	    tstart, "fgets", s,size,stream, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_FGETS_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




int __real_unlink(MPI3CONST char *pathname);


/* ---- wrapping unlink ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         int
 * CFNAME       unlink 
 * CPARAMS      MPI3CONST char *pathname
 * CARGS        pathname
 * CARGFMT      '%s'
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
int unlink(MPI3CONST char *pathname)
#else
int __wrap_unlink(MPI3CONST char *pathname)
#endif
{
  static int loaded=0;
  static int (*unlink_real)(MPI3CONST char *pathname);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  int rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    unlink_real=0;
    unlink_real=(int (*)(MPI3CONST char *pathname)) dlsym(RTLD_NEXT, 
						      "unlink");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading unlink \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=unlink_real(pathname);
#else
  rv=__real_unlink(pathname); 
#endif
#else
#ifdef HAVE_DYNLOAD
  unlink_real(pathname);
#else
  __real_unlink(pathname); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s('%s') %u bytes %g sec\n", tstart, rv, "unlink", pathname, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s('%s') %u bytes %g sec\n", 
	    tstart, "unlink", pathname, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_UNLINK_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




int __real_unlinkat(int dirfd, MPI3CONST char *pathname, int flags);


/* ---- wrapping unlinkat ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         int
 * CFNAME       unlinkat 
 * CPARAMS      int dirfd, MPI3CONST char *pathname, int flags
 * CARGS        dirfd,pathname,flags
 * CARGFMT      %d,'%s',%d
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
int unlinkat(int dirfd, MPI3CONST char *pathname, int flags)
#else
int __wrap_unlinkat(int dirfd, MPI3CONST char *pathname, int flags)
#endif
{
  static int loaded=0;
  static int (*unlinkat_real)(int dirfd, MPI3CONST char *pathname, int flags);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  int rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    unlinkat_real=0;
    unlinkat_real=(int (*)(int dirfd, MPI3CONST char *pathname, int flags)) dlsym(RTLD_NEXT, 
						      "unlinkat");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading unlinkat \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=unlinkat_real(dirfd,pathname,flags);
#else
  rv=__real_unlinkat(dirfd,pathname,flags); 
#endif
#else
#ifdef HAVE_DYNLOAD
  unlinkat_real(dirfd,pathname,flags);
#else
  __real_unlinkat(dirfd,pathname,flags); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%d,'%s',%d) %u bytes %g sec\n", tstart, rv, "unlinkat", dirfd,pathname,flags, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%d,'%s',%d) %u bytes %g sec\n", 
	    tstart, "unlinkat", dirfd,pathname,flags, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_UNLINKAT_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




int __real_fseeko(FILE *stream, off_t offset, int whence);


/* ---- wrapping fseeko ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         int
 * CFNAME       fseeko 
 * CPARAMS      FILE *stream, off_t offset, int whence
 * CARGS        stream,offset,whence
 * CARGFMT      %p,%d,%d
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
int fseeko(FILE *stream, off_t offset, int whence)
#else
int __wrap_fseeko(FILE *stream, off_t offset, int whence)
#endif
{
  static int loaded=0;
  static int (*fseeko_real)(FILE *stream, off_t offset, int whence);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  int rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    fseeko_real=0;
    fseeko_real=(int (*)(FILE *stream, off_t offset, int whence)) dlsym(RTLD_NEXT, 
						      "fseeko");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading fseeko \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=fseeko_real(stream,offset,whence);
#else
  rv=__real_fseeko(stream,offset,whence); 
#endif
#else
#ifdef HAVE_DYNLOAD
  fseeko_real(stream,offset,whence);
#else
  __real_fseeko(stream,offset,whence); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%p,%d,%d) %u bytes %g sec\n", tstart, rv, "fseeko", stream,offset,whence, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%p,%d,%d) %u bytes %g sec\n", 
	    tstart, "fseeko", stream,offset,whence, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_FSEEKO_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




int __real_fseeko64(FILE *stream, off64_t offset, int whence);


/* ---- wrapping fseeko64 ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         int
 * CFNAME       fseeko64 
 * CPARAMS      FILE *stream, off64_t offset, int whence
 * CARGS        stream,offset,whence
 * CARGFMT      %p,%l,%d
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_NONE_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
int fseeko64(FILE *stream, off64_t offset, int whence)
#else
int __wrap_fseeko64(FILE *stream, off64_t offset, int whence)
#endif
{
  static int loaded=0;
  static int (*fseeko64_real)(FILE *stream, off64_t offset, int whence);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  int rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    fseeko64_real=0;
    fseeko64_real=(int (*)(FILE *stream, off64_t offset, int whence)) dlsym(RTLD_NEXT, 
						      "fseeko64");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading fseeko64 \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=fseeko64_real(stream,offset,whence);
#else
  rv=__real_fseeko64(stream,offset,whence); 
#endif
#else
#ifdef HAVE_DYNLOAD
  fseeko64_real(stream,offset,whence);
#else
  __real_fseeko64(stream,offset,whence); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_NONE_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%p,%l,%d) %u bytes %g sec\n", tstart, rv, "fseeko64", stream,offset,whence, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%p,%l,%d) %u bytes %g sec\n", 
	    tstart, "fseeko64", stream,offset,whence, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_FSEEKO64_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




ssize_t __real_writev(int fd, MPI3CONST struct iovec *iov, int iovcnt);


/* ---- wrapping writev ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         ssize_t
 * CFNAME       writev 
 * CPARAMS      int fd, MPI3CONST struct iovec *iov, int iovcnt
 * CARGS        fd,iov,iovcnt
 * CARGFMT      %d,%p,%d
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_RETURN_COUNT_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
ssize_t writev(int fd, MPI3CONST struct iovec *iov, int iovcnt)
#else
ssize_t __wrap_writev(int fd, MPI3CONST struct iovec *iov, int iovcnt)
#endif
{
  static int loaded=0;
  static ssize_t (*writev_real)(int fd, MPI3CONST struct iovec *iov, int iovcnt);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  ssize_t rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    writev_real=0;
    writev_real=(ssize_t (*)(int fd, MPI3CONST struct iovec *iov, int iovcnt)) dlsym(RTLD_NEXT, 
						      "writev");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading writev \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=writev_real(fd,iov,iovcnt);
#else
  rv=__real_writev(fd,iov,iovcnt); 
#endif
#else
#ifdef HAVE_DYNLOAD
  writev_real(fd,iov,iovcnt);
#else
  __real_writev(fd,iov,iovcnt); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_RETURN_COUNT_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%d,%p,%d) %u bytes %g sec\n", tstart, rv, "writev", fd,iov,iovcnt, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%d,%p,%d) %u bytes %g sec\n", 
	    tstart, "writev", fd,iov,iovcnt, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_WRITEV_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




ssize_t __real_readv(int fd, MPI3CONST struct iovec *iov, int iovcnt);


/* ---- wrapping readv ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         ssize_t
 * CFNAME       readv 
 * CPARAMS      int fd, MPI3CONST struct iovec *iov, int iovcnt
 * CARGS        fd,iov,iovcnt
 * CARGFMT      %d,%p,%d
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_RETURN_COUNT_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
ssize_t readv(int fd, MPI3CONST struct iovec *iov, int iovcnt)
#else
ssize_t __wrap_readv(int fd, MPI3CONST struct iovec *iov, int iovcnt)
#endif
{
  static int loaded=0;
  static ssize_t (*readv_real)(int fd, MPI3CONST struct iovec *iov, int iovcnt);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  ssize_t rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    readv_real=0;
    readv_real=(ssize_t (*)(int fd, MPI3CONST struct iovec *iov, int iovcnt)) dlsym(RTLD_NEXT, 
						      "readv");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading readv \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=readv_real(fd,iov,iovcnt);
#else
  rv=__real_readv(fd,iov,iovcnt); 
#endif
#else
#ifdef HAVE_DYNLOAD
  readv_real(fd,iov,iovcnt);
#else
  __real_readv(fd,iov,iovcnt); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_RETURN_COUNT_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%d,%p,%d) %u bytes %g sec\n", tstart, rv, "readv", fd,iov,iovcnt, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%d,%p,%d) %u bytes %g sec\n", 
	    tstart, "readv", fd,iov,iovcnt, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_READV_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




ssize_t __real_pwritev(int fd, MPI3CONST struct iovec *iov, int iovcnt, off_t offset);


/* ---- wrapping pwritev ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         ssize_t
 * CFNAME       pwritev 
 * CPARAMS      int fd, MPI3CONST struct iovec *iov, int iovcnt, off_t offset
 * CARGS        fd,iov,iovcnt,offset
 * CARGFMT      %d,%p,%d,%d
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_RETURN_COUNT_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
ssize_t pwritev(int fd, MPI3CONST struct iovec *iov, int iovcnt, off_t offset)
#else
ssize_t __wrap_pwritev(int fd, MPI3CONST struct iovec *iov, int iovcnt, off_t offset)
#endif
{
  static int loaded=0;
  static ssize_t (*pwritev_real)(int fd, MPI3CONST struct iovec *iov, int iovcnt, off_t offset);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  ssize_t rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    pwritev_real=0;
    pwritev_real=(ssize_t (*)(int fd, MPI3CONST struct iovec *iov, int iovcnt, off_t offset)) dlsym(RTLD_NEXT, 
						      "pwritev");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading pwritev \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=pwritev_real(fd,iov,iovcnt,offset);
#else
  rv=__real_pwritev(fd,iov,iovcnt,offset); 
#endif
#else
#ifdef HAVE_DYNLOAD
  pwritev_real(fd,iov,iovcnt,offset);
#else
  __real_pwritev(fd,iov,iovcnt,offset); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_RETURN_COUNT_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%d,%p,%d,%d) %u bytes %g sec\n", tstart, rv, "pwritev", fd,iov,iovcnt,offset, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%d,%p,%d,%d) %u bytes %g sec\n", 
	    tstart, "pwritev", fd,iov,iovcnt,offset, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_PWRITEV_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}




ssize_t __real_preadv(int fd, MPI3CONST struct iovec *iov, int iovcnt, off_t offset);


/* ---- wrapping preadv ---- */
/*
 * strings in the form __IDENT__ are replaced by the wrapper script
 *
 * CRET         ssize_t
 * CFNAME       preadv 
 * CPARAMS      int fd, MPI3CONST struct iovec *iov, int iovcnt, off_t offset
 * CARGS        fd,iov,iovcnt,offset
 * CARGFMT      %d,%p,%d,%d
 * CRETFMT      %d
 * GET_SSIZE    __GET_SSIZE__
 * GET_RSIZE    __GET_RSIZE__
 * GET_RANK     IPM_POSIXIO_RANK_NONE_C
 * GET_BYTES    IPM_POSIXIO_BYTES_RETURN_COUNT_C
 * RETURN_VALUE 1
 */

#ifdef HAVE_DYNLOAD
ssize_t preadv(int fd, MPI3CONST struct iovec *iov, int iovcnt, off_t offset)
#else
ssize_t __wrap_preadv(int fd, MPI3CONST struct iovec *iov, int iovcnt, off_t offset)
#endif
{
  static int loaded=0;
  static ssize_t (*preadv_real)(int fd, MPI3CONST struct iovec *iov, int iovcnt, off_t offset);
  int bytes, irank;
  int csite, idx, idx2, regid; 
  double tstart, tstop, t;
  IPM_KEY_TYPE key;

#if 1
  ssize_t rv;
#endif
  
#ifdef HAVE_DYNLOAD
  if(!loaded) {
    preadv_real=0;
    preadv_real=(ssize_t (*)(int fd, MPI3CONST struct iovec *iov, int iovcnt, off_t offset)) dlsym(RTLD_NEXT, 
						      "preadv");
    
    if(!dlerror()) loaded=1;
    else {
      fprintf(stderr, "Error loading preadv \n");
      /* handle error */
    }
  }
#endif /* HAVE_DYNLOAD */

  if( ipm_state==STATE_NOTINIT ) {
#ifndef HAVE_MPI
    ipm_init(0);
#endif
  }

  IPM_TIMESTAMP(tstart);

#if 1
#ifdef HAVE_DYNLOAD
  rv=preadv_real(fd,iov,iovcnt,offset);
#else
  rv=__real_preadv(fd,iov,iovcnt,offset); 
#endif
#else
#ifdef HAVE_DYNLOAD
  preadv_real(fd,iov,iovcnt,offset);
#else
  __real_preadv(fd,iov,iovcnt,offset); 
#endif
#endif 
  IPM_TIMESTAMP(tstop); t=tstop-tstart;

  if( ipm_state!=STATE_ACTIVE || 
      modules[IPM_MODULE_POSIXIO].state!=STATE_ACTIVE ) { 
#if 1
    return rv;
#else
    return;
#endif
  }
  
  IPM_POSIXIO_BYTES_RETURN_COUNT_C(bytes);

  csite=0;
#ifdef HAVE_CALLPATH
  /* csite=get_callsite_id(); */
#endif 

  regid=ipm_rstackptr->id;

#ifdef HAVE_POSIXIO_TRACE
  if( task.tracestate && task.tracefile ) {
    
    ipm_state=STATE_NOTACTIVE;
        
#if 1
    fprintf(task.tracefile, "%10.6f %d %s(%d,%p,%d,%d) %u bytes %g sec\n", tstart, rv, "preadv", fd,iov,iovcnt,offset, bytes, t );
#else
    fprintf(task.tracefile, "%10.6f %s(%d,%p,%d,%d) %u bytes %g sec\n", 
	    tstart, "preadv", fd,iov,iovcnt,offset, bytes, t);
#endif
    fflush(task.tracefile);    

    ipm_state=STATE_ACTIVE;

  }

#endif
    
  IPM_POSIXIO_KEY(key, PIO_PREADV_ID_GLOBAL, 0, bytes, regid, csite);

  IPM_HASH_HKEY(ipm_htable, key, idx);

#ifdef HAVE_KEYHIST
  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);
  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif
  
  IPM_HASHTABLE_ADD(idx,t);
  
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif

#if 1
    return rv;
#else
    return;
#endif
}

