/*
 * GEN.wrapper_mpi.c
 * DO NOT EDIT: automatically generated at build time
 */

#include <mpi.h>
#include <sys/stat.h>

#include "ipm.h"
#include "hashtable.h"
#include "ipm_core.h"
#include "mod_mpi.h"
#include "GEN.calltable_mpi.h"

#include "regstack.h"

#ifdef HAVE_CALLPATH
#include "mod_callpath.h"
#endif

#ifdef HAVE_KEYHIST
#include "mod_keyhist.h"
#endif

#ifndef MPI3CONST
#if MPI_VERSION >= 3 
#define MPI3CONST const
#else
#define MPI3CONST 
#endif 
#endif





/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_COMM_RANK_ID)

/* ---- wrapping MPI_Comm_rank ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Comm_rank 
 * CPARAMS    MPI_Comm comm_in, int *rank
 * CARGS      comm_in,rank
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_NONE_C
 * GET_RANK   IPM_MPI_RANK_NONE_C
 */

void IPM_MPI_Comm_rank(MPI_Comm comm_in, int *rank, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_NONE_C(bytes); 
  IPM_MPI_RANK_NONE_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_COMM_RANK_ID_GLOBAL, "MPI_Comm_rank", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_COMM_RANK_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_COMM_RANK_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_COMM_RANK_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_COMM_RANK_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Comm_rank(MPI_Comm comm_in, int *rank)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Comm_rank(comm_in,rank);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Comm_rank(comm_in,rank, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_COMM_SIZE_ID)

/* ---- wrapping MPI_Comm_size ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Comm_size 
 * CPARAMS    MPI_Comm comm_in, int *osize
 * CARGS      comm_in,osize
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_NONE_C
 * GET_RANK   IPM_MPI_RANK_NONE_C
 */

void IPM_MPI_Comm_size(MPI_Comm comm_in, int *osize, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_NONE_C(bytes); 
  IPM_MPI_RANK_NONE_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_COMM_SIZE_ID_GLOBAL, "MPI_Comm_size", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_COMM_SIZE_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_COMM_SIZE_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_COMM_SIZE_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_COMM_SIZE_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Comm_size(MPI_Comm comm_in, int *osize)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Comm_size(comm_in,osize);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Comm_size(comm_in,osize, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_SEND_ID)

/* ---- wrapping MPI_Send ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Send 
 * CPARAMS    MPI3CONST void *sbuf, int scount, MPI_Datatype stype, int dest, int tag, MPI_Comm comm_in
 * CARGS      sbuf,scount,stype,dest,tag,comm_in
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNT_C
 * GET_RANK   IPM_MPI_RANK_DEST_C
 */

void IPM_MPI_Send(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, int dest, int tag, MPI_Comm comm_in, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNT_C(bytes); 
  IPM_MPI_RANK_DEST_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_SEND_ID_GLOBAL, "MPI_Send", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_SEND_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_SEND_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_SEND_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_SEND_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Send(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, int dest, int tag, MPI_Comm comm_in)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Send(sbuf,scount,stype,dest,tag,comm_in);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Send(sbuf,scount,stype,dest,tag,comm_in, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_SSEND_ID)

/* ---- wrapping MPI_Ssend ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Ssend 
 * CPARAMS    MPI3CONST void *sbuf, int scount, MPI_Datatype stype, int dest, int tag, MPI_Comm comm_in
 * CARGS      sbuf,scount,stype,dest,tag,comm_in
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNT_C
 * GET_RANK   IPM_MPI_RANK_DEST_C
 */

void IPM_MPI_Ssend(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, int dest, int tag, MPI_Comm comm_in, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNT_C(bytes); 
  IPM_MPI_RANK_DEST_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_SSEND_ID_GLOBAL, "MPI_Ssend", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_SSEND_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_SSEND_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_SSEND_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_SSEND_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Ssend(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, int dest, int tag, MPI_Comm comm_in)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Ssend(sbuf,scount,stype,dest,tag,comm_in);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Ssend(sbuf,scount,stype,dest,tag,comm_in, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_RSEND_ID)

/* ---- wrapping MPI_Rsend ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Rsend 
 * CPARAMS    MPI3CONST void *sbuf, int scount, MPI_Datatype stype, int dest, int tag, MPI_Comm comm_in
 * CARGS      sbuf,scount,stype,dest,tag,comm_in
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNT_C
 * GET_RANK   IPM_MPI_RANK_DEST_C
 */

void IPM_MPI_Rsend(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, int dest, int tag, MPI_Comm comm_in, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNT_C(bytes); 
  IPM_MPI_RANK_DEST_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_RSEND_ID_GLOBAL, "MPI_Rsend", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_RSEND_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_RSEND_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_RSEND_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_RSEND_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Rsend(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, int dest, int tag, MPI_Comm comm_in)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Rsend(sbuf,scount,stype,dest,tag,comm_in);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Rsend(sbuf,scount,stype,dest,tag,comm_in, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_BSEND_ID)

/* ---- wrapping MPI_Bsend ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Bsend 
 * CPARAMS    MPI3CONST void *sbuf, int scount, MPI_Datatype stype, int dest, int tag, MPI_Comm comm_in
 * CARGS      sbuf,scount,stype,dest,tag,comm_in
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNT_C
 * GET_RANK   IPM_MPI_RANK_DEST_C
 */

void IPM_MPI_Bsend(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, int dest, int tag, MPI_Comm comm_in, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNT_C(bytes); 
  IPM_MPI_RANK_DEST_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_BSEND_ID_GLOBAL, "MPI_Bsend", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_BSEND_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_BSEND_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_BSEND_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_BSEND_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Bsend(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, int dest, int tag, MPI_Comm comm_in)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Bsend(sbuf,scount,stype,dest,tag,comm_in);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Bsend(sbuf,scount,stype,dest,tag,comm_in, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_ISEND_ID)

/* ---- wrapping MPI_Isend ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Isend 
 * CPARAMS    MPI3CONST void *sbuf, int scount, MPI_Datatype stype, int dest, int tag, MPI_Comm comm_in, MPI_Request *req
 * CARGS      sbuf,scount,stype,dest,tag,comm_in,req
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNT_C
 * GET_RANK   IPM_MPI_RANK_DEST_C
 */

void IPM_MPI_Isend(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, int dest, int tag, MPI_Comm comm_in, MPI_Request *req, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNT_C(bytes); 
  IPM_MPI_RANK_DEST_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_ISEND_ID_GLOBAL, "MPI_Isend", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_ISEND_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_ISEND_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_ISEND_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_ISEND_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Isend(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, int dest, int tag, MPI_Comm comm_in, MPI_Request *req)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Isend(sbuf,scount,stype,dest,tag,comm_in,req);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Isend(sbuf,scount,stype,dest,tag,comm_in,req, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_ISSEND_ID)

/* ---- wrapping MPI_Issend ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Issend 
 * CPARAMS    MPI3CONST void *sbuf, int scount, MPI_Datatype stype, int dest, int tag, MPI_Comm comm_in, MPI_Request *req
 * CARGS      sbuf,scount,stype,dest,tag,comm_in,req
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNT_C
 * GET_RANK   IPM_MPI_RANK_DEST_C
 */

void IPM_MPI_Issend(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, int dest, int tag, MPI_Comm comm_in, MPI_Request *req, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNT_C(bytes); 
  IPM_MPI_RANK_DEST_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_ISSEND_ID_GLOBAL, "MPI_Issend", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_ISSEND_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_ISSEND_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_ISSEND_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_ISSEND_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Issend(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, int dest, int tag, MPI_Comm comm_in, MPI_Request *req)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Issend(sbuf,scount,stype,dest,tag,comm_in,req);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Issend(sbuf,scount,stype,dest,tag,comm_in,req, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_IRSEND_ID)

/* ---- wrapping MPI_Irsend ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Irsend 
 * CPARAMS    MPI3CONST void *sbuf, int scount, MPI_Datatype stype, int dest, int tag, MPI_Comm comm_in, MPI_Request *req
 * CARGS      sbuf,scount,stype,dest,tag,comm_in,req
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNT_C
 * GET_RANK   IPM_MPI_RANK_DEST_C
 */

void IPM_MPI_Irsend(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, int dest, int tag, MPI_Comm comm_in, MPI_Request *req, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNT_C(bytes); 
  IPM_MPI_RANK_DEST_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_IRSEND_ID_GLOBAL, "MPI_Irsend", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_IRSEND_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_IRSEND_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_IRSEND_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_IRSEND_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Irsend(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, int dest, int tag, MPI_Comm comm_in, MPI_Request *req)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Irsend(sbuf,scount,stype,dest,tag,comm_in,req);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Irsend(sbuf,scount,stype,dest,tag,comm_in,req, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_IBSEND_ID)

/* ---- wrapping MPI_Ibsend ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Ibsend 
 * CPARAMS    MPI3CONST void *sbuf, int scount, MPI_Datatype stype, int dest, int tag, MPI_Comm comm_in, MPI_Request *req
 * CARGS      sbuf,scount,stype,dest,tag,comm_in,req
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNT_C
 * GET_RANK   IPM_MPI_RANK_DEST_C
 */

void IPM_MPI_Ibsend(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, int dest, int tag, MPI_Comm comm_in, MPI_Request *req, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNT_C(bytes); 
  IPM_MPI_RANK_DEST_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_IBSEND_ID_GLOBAL, "MPI_Ibsend", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_IBSEND_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_IBSEND_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_IBSEND_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_IBSEND_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Ibsend(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, int dest, int tag, MPI_Comm comm_in, MPI_Request *req)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Ibsend(sbuf,scount,stype,dest,tag,comm_in,req);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Ibsend(sbuf,scount,stype,dest,tag,comm_in,req, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_RECV_ID)

/* ---- wrapping MPI_Recv ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Recv 
 * CPARAMS    void *rbuf, int rcount, MPI_Datatype rtype, int src, int tag, MPI_Comm comm_in, MPI_Status *status
 * CARGS      rbuf,rcount,rtype,src,tag,comm_in,status
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_STATUS_C
 * GET_RANK   IPM_MPI_RANK_STATUS_C
 */

void IPM_MPI_Recv(void *rbuf, int rcount, MPI_Datatype rtype, int src, int tag, MPI_Comm comm_in, MPI_Status *status, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_STATUS_C(bytes); 
  IPM_MPI_RANK_STATUS_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_RECV_ID_GLOBAL, "MPI_Recv", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_RECV_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_RECV_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_RECV_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_RECV_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Recv(void *rbuf, int rcount, MPI_Datatype rtype, int src, int tag, MPI_Comm comm_in, MPI_Status *status)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Recv(rbuf,rcount,rtype,src,tag,comm_in,status);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Recv(rbuf,rcount,rtype,src,tag,comm_in,status, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_IRECV_ID)

/* ---- wrapping MPI_Irecv ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Irecv 
 * CPARAMS    void *rbuf, int rcount, MPI_Datatype rtype, int src, int tag, MPI_Comm comm_in, MPI_Request *req
 * CARGS      rbuf,rcount,rtype,src,tag,comm_in,req
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_RCOUNT_C
 * GET_RANK   IPM_MPI_RANK_SRC_C
 */

void IPM_MPI_Irecv(void *rbuf, int rcount, MPI_Datatype rtype, int src, int tag, MPI_Comm comm_in, MPI_Request *req, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_RCOUNT_C(bytes); 
  IPM_MPI_RANK_SRC_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_IRECV_ID_GLOBAL, "MPI_Irecv", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_IRECV_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_IRECV_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_IRECV_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_IRECV_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Irecv(void *rbuf, int rcount, MPI_Datatype rtype, int src, int tag, MPI_Comm comm_in, MPI_Request *req)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Irecv(rbuf,rcount,rtype,src,tag,comm_in,req);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Irecv(rbuf,rcount,rtype,src,tag,comm_in,req, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_SENDRECV_ID)

/* ---- wrapping MPI_Sendrecv ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Sendrecv 
 * CPARAMS    MPI3CONST void *sbuf, int scount, MPI_Datatype stype, int dest, int stag, void *rbuf, int rcount, MPI_Datatype rtype, int src, int rtag, MPI_Comm comm_in, MPI_Status *status
 * CARGS      sbuf,scount,stype,dest,stag,rbuf,rcount,rtype,src,rtag,comm_in,status
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNT_C
 * GET_RANK   IPM_MPI_RANK_DEST_C
 */

void IPM_MPI_Sendrecv(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, int dest, int stag, void *rbuf, int rcount, MPI_Datatype rtype, int src, int rtag, MPI_Comm comm_in, MPI_Status *status, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNT_C(bytes); 
  IPM_MPI_RANK_DEST_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_SENDRECV_ID_GLOBAL, "MPI_Sendrecv", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_SENDRECV_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_SENDRECV_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_SENDRECV_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_SENDRECV_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Sendrecv(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, int dest, int stag, void *rbuf, int rcount, MPI_Datatype rtype, int src, int rtag, MPI_Comm comm_in, MPI_Status *status)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Sendrecv(sbuf,scount,stype,dest,stag,rbuf,rcount,rtype,src,rtag,comm_in,status);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Sendrecv(sbuf,scount,stype,dest,stag,rbuf,rcount,rtype,src,rtag,comm_in,status, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_SENDRECV_REPLACE_ID)

/* ---- wrapping MPI_Sendrecv_replace ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Sendrecv_replace 
 * CPARAMS    void *sbuf, int scount, MPI_Datatype stype, int dest, int stag, int src, int rtag, MPI_Comm comm_in, MPI_Status *status
 * CARGS      sbuf,scount,stype,dest,stag,src,rtag,comm_in,status
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNT_C
 * GET_RANK   IPM_MPI_RANK_DEST_C
 */

void IPM_MPI_Sendrecv_replace(void *sbuf, int scount, MPI_Datatype stype, int dest, int stag, int src, int rtag, MPI_Comm comm_in, MPI_Status *status, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNT_C(bytes); 
  IPM_MPI_RANK_DEST_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_SENDRECV_REPLACE_ID_GLOBAL, "MPI_Sendrecv_replace", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_SENDRECV_REPLACE_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_SENDRECV_REPLACE_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_SENDRECV_REPLACE_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_SENDRECV_REPLACE_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Sendrecv_replace(void *sbuf, int scount, MPI_Datatype stype, int dest, int stag, int src, int rtag, MPI_Comm comm_in, MPI_Status *status)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Sendrecv_replace(sbuf,scount,stype,dest,stag,src,rtag,comm_in,status);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Sendrecv_replace(sbuf,scount,stype,dest,stag,src,rtag,comm_in,status, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_WAIT_ID)

/* ---- wrapping MPI_Wait ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Wait 
 * CPARAMS    MPI_Request *request, MPI_Status *status
 * CARGS      request,status
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_STATUS_C
 * GET_RANK   IPM_MPI_RANK_NONE_C
 */

void IPM_MPI_Wait(MPI_Request *request, MPI_Status *status, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_STATUS_C(bytes); 
  IPM_MPI_RANK_NONE_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_WAIT_ID_GLOBAL, "MPI_Wait", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_WAIT_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_WAIT_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_WAIT_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_WAIT_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Wait(MPI_Request *request, MPI_Status *status)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Wait(request,status);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Wait(request,status, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif
/* NOTE: mpi_wait_ NOT WRAPPED */




/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_WAITANY_ID)

/* ---- wrapping MPI_Waitany ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Waitany 
 * CPARAMS    int num, MPI_Request *requests, int *indx, MPI_Status *status
 * CARGS      num,requests,indx,status
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_STATUS_C
 * GET_RANK   IPM_MPI_RANK_NONE_C
 */

void IPM_MPI_Waitany(int num, MPI_Request *requests, int *indx, MPI_Status *status, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_STATUS_C(bytes); 
  IPM_MPI_RANK_NONE_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_WAITANY_ID_GLOBAL, "MPI_Waitany", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_WAITANY_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_WAITANY_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_WAITANY_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_WAITANY_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Waitany(int num, MPI_Request *requests, int *indx, MPI_Status *status)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Waitany(num,requests,indx,status);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Waitany(num,requests,indx,status, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif
/* NOTE: mpi_waitany_ NOT WRAPPED */




/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_WAITALL_ID)

/* ---- wrapping MPI_Waitall ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Waitall 
 * CPARAMS    int num, MPI_Request *requests, MPI_Status *statuses
 * CARGS      num,requests,statuses
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_STATUSES_C
 * GET_RANK   IPM_MPI_RANK_NONE_C
 */

void IPM_MPI_Waitall(int num, MPI_Request *requests, MPI_Status *statuses, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_STATUSES_C(bytes); 
  IPM_MPI_RANK_NONE_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_WAITALL_ID_GLOBAL, "MPI_Waitall", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_WAITALL_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_WAITALL_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_WAITALL_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_WAITALL_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Waitall(int num, MPI_Request *requests, MPI_Status *statuses)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Waitall(num,requests,statuses);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Waitall(num,requests,statuses, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif
/* NOTE: mpi_waitall_ NOT WRAPPED */




/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_WAITSOME_ID)

/* ---- wrapping MPI_Waitsome ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Waitsome 
 * CPARAMS    int inum, MPI_Request *requests, int *num, int *indices, MPI_Status *statuses
 * CARGS      inum,requests,num,indices,statuses
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_NONE_C
 * GET_RANK   IPM_MPI_RANK_NONE_C
 */

void IPM_MPI_Waitsome(int inum, MPI_Request *requests, int *num, int *indices, MPI_Status *statuses, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_NONE_C(bytes); 
  IPM_MPI_RANK_NONE_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_WAITSOME_ID_GLOBAL, "MPI_Waitsome", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_WAITSOME_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_WAITSOME_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_WAITSOME_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_WAITSOME_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Waitsome(int inum, MPI_Request *requests, int *num, int *indices, MPI_Status *statuses)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Waitsome(inum,requests,num,indices,statuses);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Waitsome(inum,requests,num,indices,statuses, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif
/* NOTE: mpi_waitsome_ NOT WRAPPED */




/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_PROBE_ID)

/* ---- wrapping MPI_Probe ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Probe 
 * CPARAMS    int src, int tag, MPI_Comm comm_in, MPI_Status *status
 * CARGS      src,tag,comm_in,status
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_STATUS_C
 * GET_RANK   IPM_MPI_RANK_STATUS_C
 */

void IPM_MPI_Probe(int src, int tag, MPI_Comm comm_in, MPI_Status *status, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_STATUS_C(bytes); 
  IPM_MPI_RANK_STATUS_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_PROBE_ID_GLOBAL, "MPI_Probe", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_PROBE_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_PROBE_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_PROBE_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_PROBE_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Probe(int src, int tag, MPI_Comm comm_in, MPI_Status *status)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Probe(src,tag,comm_in,status);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Probe(src,tag,comm_in,status, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_IPROBE_ID)

/* ---- wrapping MPI_Iprobe ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Iprobe 
 * CPARAMS    int src, int tag, MPI_Comm comm_in, int *flag, MPI_Status *status
 * CARGS      src,tag,comm_in,flag,status
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_NONE_C
 * GET_RANK   IPM_MPI_RANK_NONE_C
 */

void IPM_MPI_Iprobe(int src, int tag, MPI_Comm comm_in, int *flag, MPI_Status *status, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_NONE_C(bytes); 
  IPM_MPI_RANK_NONE_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_IPROBE_ID_GLOBAL, "MPI_Iprobe", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_IPROBE_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_IPROBE_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_IPROBE_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_IPROBE_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Iprobe(int src, int tag, MPI_Comm comm_in, int *flag, MPI_Status *status)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Iprobe(src,tag,comm_in,flag,status);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Iprobe(src,tag,comm_in,flag,status, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_SEND_INIT_ID)

/* ---- wrapping MPI_Send_init ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Send_init 
 * CPARAMS    MPI3CONST void *sbuf, int scount, MPI_Datatype type, int dest, int tag, MPI_Comm comm_in, MPI_Request *req
 * CARGS      sbuf,scount,type,dest,tag,comm_in,req
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_NONE_C
 * GET_RANK   IPM_MPI_RANK_DEST_C
 */

void IPM_MPI_Send_init(MPI3CONST void *sbuf, int scount, MPI_Datatype type, int dest, int tag, MPI_Comm comm_in, MPI_Request *req, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_NONE_C(bytes); 
  IPM_MPI_RANK_DEST_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_SEND_INIT_ID_GLOBAL, "MPI_Send_init", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_SEND_INIT_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_SEND_INIT_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_SEND_INIT_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_SEND_INIT_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Send_init(MPI3CONST void *sbuf, int scount, MPI_Datatype type, int dest, int tag, MPI_Comm comm_in, MPI_Request *req)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Send_init(sbuf,scount,type,dest,tag,comm_in,req);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Send_init(sbuf,scount,type,dest,tag,comm_in,req, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_SSEND_INIT_ID)

/* ---- wrapping MPI_Ssend_init ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Ssend_init 
 * CPARAMS    MPI3CONST void *sbuf, int scount, MPI_Datatype type, int dest, int tag, MPI_Comm comm_in, MPI_Request *req
 * CARGS      sbuf,scount,type,dest,tag,comm_in,req
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_NONE_C
 * GET_RANK   IPM_MPI_RANK_DEST_C
 */

void IPM_MPI_Ssend_init(MPI3CONST void *sbuf, int scount, MPI_Datatype type, int dest, int tag, MPI_Comm comm_in, MPI_Request *req, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_NONE_C(bytes); 
  IPM_MPI_RANK_DEST_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_SSEND_INIT_ID_GLOBAL, "MPI_Ssend_init", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_SSEND_INIT_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_SSEND_INIT_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_SSEND_INIT_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_SSEND_INIT_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Ssend_init(MPI3CONST void *sbuf, int scount, MPI_Datatype type, int dest, int tag, MPI_Comm comm_in, MPI_Request *req)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Ssend_init(sbuf,scount,type,dest,tag,comm_in,req);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Ssend_init(sbuf,scount,type,dest,tag,comm_in,req, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_RSEND_INIT_ID)

/* ---- wrapping MPI_Rsend_init ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Rsend_init 
 * CPARAMS    MPI3CONST void *sbuf, int scount, MPI_Datatype type, int dest, int tag, MPI_Comm comm_in, MPI_Request *req
 * CARGS      sbuf,scount,type,dest,tag,comm_in,req
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_NONE_C
 * GET_RANK   IPM_MPI_RANK_DEST_C
 */

void IPM_MPI_Rsend_init(MPI3CONST void *sbuf, int scount, MPI_Datatype type, int dest, int tag, MPI_Comm comm_in, MPI_Request *req, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_NONE_C(bytes); 
  IPM_MPI_RANK_DEST_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_RSEND_INIT_ID_GLOBAL, "MPI_Rsend_init", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_RSEND_INIT_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_RSEND_INIT_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_RSEND_INIT_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_RSEND_INIT_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Rsend_init(MPI3CONST void *sbuf, int scount, MPI_Datatype type, int dest, int tag, MPI_Comm comm_in, MPI_Request *req)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Rsend_init(sbuf,scount,type,dest,tag,comm_in,req);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Rsend_init(sbuf,scount,type,dest,tag,comm_in,req, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_BSEND_INIT_ID)

/* ---- wrapping MPI_Bsend_init ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Bsend_init 
 * CPARAMS    MPI3CONST void *sbuf, int scount, MPI_Datatype type, int dest, int tag, MPI_Comm comm_in, MPI_Request *req
 * CARGS      sbuf,scount,type,dest,tag,comm_in,req
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_NONE_C
 * GET_RANK   IPM_MPI_RANK_DEST_C
 */

void IPM_MPI_Bsend_init(MPI3CONST void *sbuf, int scount, MPI_Datatype type, int dest, int tag, MPI_Comm comm_in, MPI_Request *req, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_NONE_C(bytes); 
  IPM_MPI_RANK_DEST_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_BSEND_INIT_ID_GLOBAL, "MPI_Bsend_init", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_BSEND_INIT_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_BSEND_INIT_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_BSEND_INIT_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_BSEND_INIT_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Bsend_init(MPI3CONST void *sbuf, int scount, MPI_Datatype type, int dest, int tag, MPI_Comm comm_in, MPI_Request *req)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Bsend_init(sbuf,scount,type,dest,tag,comm_in,req);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Bsend_init(sbuf,scount,type,dest,tag,comm_in,req, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_RECV_INIT_ID)

/* ---- wrapping MPI_Recv_init ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Recv_init 
 * CPARAMS    void *rbuf, int rcount, MPI_Datatype type, int src, int tag, MPI_Comm comm_in, MPI_Request *req
 * CARGS      rbuf,rcount,type,src,tag,comm_in,req
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_NONE_C
 * GET_RANK   IPM_MPI_RANK_SRC_C
 */

void IPM_MPI_Recv_init(void *rbuf, int rcount, MPI_Datatype type, int src, int tag, MPI_Comm comm_in, MPI_Request *req, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_NONE_C(bytes); 
  IPM_MPI_RANK_SRC_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_RECV_INIT_ID_GLOBAL, "MPI_Recv_init", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_RECV_INIT_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_RECV_INIT_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_RECV_INIT_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_RECV_INIT_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Recv_init(void *rbuf, int rcount, MPI_Datatype type, int src, int tag, MPI_Comm comm_in, MPI_Request *req)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Recv_init(rbuf,rcount,type,src,tag,comm_in,req);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Recv_init(rbuf,rcount,type,src,tag,comm_in,req, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_BUFFER_ATTACH_ID)

/* ---- wrapping MPI_Buffer_attach ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Buffer_attach 
 * CPARAMS    void *buffer, int size
 * CARGS      buffer,size
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_NONE_C
 * GET_RANK   IPM_MPI_RANK_NONE_C
 */

void IPM_MPI_Buffer_attach(void *buffer, int size, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_NONE_C(bytes); 
  IPM_MPI_RANK_NONE_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_BUFFER_ATTACH_ID_GLOBAL, "MPI_Buffer_attach", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_BUFFER_ATTACH_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_BUFFER_ATTACH_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_BUFFER_ATTACH_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_BUFFER_ATTACH_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Buffer_attach(void *buffer, int size)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Buffer_attach(buffer,size);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Buffer_attach(buffer,size, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_BUFFER_DETACH_ID)

/* ---- wrapping MPI_Buffer_detach ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Buffer_detach 
 * CPARAMS    void *buffer, int *osize
 * CARGS      buffer,osize
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_NONE_C
 * GET_RANK   IPM_MPI_RANK_NONE_C
 */

void IPM_MPI_Buffer_detach(void *buffer, int *osize, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_NONE_C(bytes); 
  IPM_MPI_RANK_NONE_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_BUFFER_DETACH_ID_GLOBAL, "MPI_Buffer_detach", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_BUFFER_DETACH_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_BUFFER_DETACH_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_BUFFER_DETACH_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_BUFFER_DETACH_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Buffer_detach(void *buffer, int *osize)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Buffer_detach(buffer,osize);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Buffer_detach(buffer,osize, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_TEST_ID)

/* ---- wrapping MPI_Test ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Test 
 * CPARAMS    MPI_Request *request, int *flag, MPI_Status *status
 * CARGS      request,flag,status
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_NONE_C
 * GET_RANK   IPM_MPI_RANK_NONE_C
 */

void IPM_MPI_Test(MPI_Request *request, int *flag, MPI_Status *status, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_NONE_C(bytes); 
  IPM_MPI_RANK_NONE_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_TEST_ID_GLOBAL, "MPI_Test", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_TEST_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_TEST_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_TEST_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_TEST_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Test(MPI_Request *request, int *flag, MPI_Status *status)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Test(request,flag,status);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Test(request,flag,status, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif
/* NOTE: mpi_test_ NOT WRAPPED */




/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_TESTANY_ID)

/* ---- wrapping MPI_Testany ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Testany 
 * CPARAMS    int num, MPI_Request *requests, int *indx, int *flag, MPI_Status *status
 * CARGS      num,requests,indx,flag,status
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_NONE_C
 * GET_RANK   IPM_MPI_RANK_NONE_C
 */

void IPM_MPI_Testany(int num, MPI_Request *requests, int *indx, int *flag, MPI_Status *status, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_NONE_C(bytes); 
  IPM_MPI_RANK_NONE_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_TESTANY_ID_GLOBAL, "MPI_Testany", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_TESTANY_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_TESTANY_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_TESTANY_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_TESTANY_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Testany(int num, MPI_Request *requests, int *indx, int *flag, MPI_Status *status)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Testany(num,requests,indx,flag,status);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Testany(num,requests,indx,flag,status, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif
/* NOTE: mpi_testany_ NOT WRAPPED */




/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_TESTALL_ID)

/* ---- wrapping MPI_Testall ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Testall 
 * CPARAMS    int num, MPI_Request *requests, int *flag, MPI_Status *statuses
 * CARGS      num,requests,flag,statuses
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_NONE_C
 * GET_RANK   IPM_MPI_RANK_NONE_C
 */

void IPM_MPI_Testall(int num, MPI_Request *requests, int *flag, MPI_Status *statuses, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_NONE_C(bytes); 
  IPM_MPI_RANK_NONE_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_TESTALL_ID_GLOBAL, "MPI_Testall", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_TESTALL_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_TESTALL_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_TESTALL_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_TESTALL_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Testall(int num, MPI_Request *requests, int *flag, MPI_Status *statuses)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Testall(num,requests,flag,statuses);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Testall(num,requests,flag,statuses, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif
/* NOTE: mpi_testall_ NOT WRAPPED */




/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_TESTSOME_ID)

/* ---- wrapping MPI_Testsome ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Testsome 
 * CPARAMS    int inum, MPI_Request *requests, int *onum, int *indices, MPI_Status *statuses
 * CARGS      inum,requests,onum,indices,statuses
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_NONE_C
 * GET_RANK   IPM_MPI_RANK_NONE_C
 */

void IPM_MPI_Testsome(int inum, MPI_Request *requests, int *onum, int *indices, MPI_Status *statuses, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_NONE_C(bytes); 
  IPM_MPI_RANK_NONE_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_TESTSOME_ID_GLOBAL, "MPI_Testsome", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_TESTSOME_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_TESTSOME_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_TESTSOME_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_TESTSOME_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Testsome(int inum, MPI_Request *requests, int *onum, int *indices, MPI_Status *statuses)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Testsome(inum,requests,onum,indices,statuses);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Testsome(inum,requests,onum,indices,statuses, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif
/* NOTE: mpi_testsome_ NOT WRAPPED */




/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_START_ID)

/* ---- wrapping MPI_Start ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Start 
 * CPARAMS    MPI_Request *req
 * CARGS      req
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_NONE_C
 * GET_RANK   IPM_MPI_RANK_NONE_C
 */

void IPM_MPI_Start(MPI_Request *req, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_NONE_C(bytes); 
  IPM_MPI_RANK_NONE_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_START_ID_GLOBAL, "MPI_Start", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_START_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_START_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_START_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_START_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Start(MPI_Request *req)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Start(req);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Start(req, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_STARTALL_ID)

/* ---- wrapping MPI_Startall ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Startall 
 * CPARAMS    int num, MPI_Request *requests
 * CARGS      num,requests
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_NONE_C
 * GET_RANK   IPM_MPI_RANK_NONE_C
 */

void IPM_MPI_Startall(int num, MPI_Request *requests, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_NONE_C(bytes); 
  IPM_MPI_RANK_NONE_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_STARTALL_ID_GLOBAL, "MPI_Startall", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_STARTALL_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_STARTALL_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_STARTALL_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_STARTALL_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Startall(int num, MPI_Request *requests)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Startall(num,requests);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Startall(num,requests, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif
/* NOTE: mpi_startall_ NOT WRAPPED */




/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_BCAST_ID)

/* ---- wrapping MPI_Bcast ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Bcast 
 * CPARAMS    void *sbuf, int scount, MPI_Datatype stype, int root, MPI_Comm comm_in
 * CARGS      sbuf,scount,stype,root,comm_in
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNT_C
 * GET_RANK   IPM_MPI_RANK_ROOT_C
 */

void IPM_MPI_Bcast(void *sbuf, int scount, MPI_Datatype stype, int root, MPI_Comm comm_in, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNT_C(bytes); 
  IPM_MPI_RANK_ROOT_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_BCAST_ID_GLOBAL, "MPI_Bcast", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_BCAST_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_BCAST_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_BCAST_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_BCAST_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Bcast(void *sbuf, int scount, MPI_Datatype stype, int root, MPI_Comm comm_in)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Bcast(sbuf,scount,stype,root,comm_in);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Bcast(sbuf,scount,stype,root,comm_in, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_REDUCE_ID)

/* ---- wrapping MPI_Reduce ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Reduce 
 * CPARAMS    MPI3CONST void *sbuf, void *rbuf, int scount, MPI_Datatype stype, MPI_Op op, int root, MPI_Comm comm_in
 * CARGS      sbuf,rbuf,scount,stype,op,root,comm_in
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNT_C
 * GET_RANK   IPM_MPI_RANK_ROOT_C
 */

void IPM_MPI_Reduce(MPI3CONST void *sbuf, void *rbuf, int scount, MPI_Datatype stype, MPI_Op op, int root, MPI_Comm comm_in, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNT_C(bytes); 
  IPM_MPI_RANK_ROOT_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_REDUCE_ID_GLOBAL, "MPI_Reduce", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_REDUCE_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_REDUCE_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_REDUCE_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_REDUCE_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Reduce(MPI3CONST void *sbuf, void *rbuf, int scount, MPI_Datatype stype, MPI_Op op, int root, MPI_Comm comm_in)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Reduce(sbuf,rbuf,scount,stype,op,root,comm_in);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Reduce(sbuf,rbuf,scount,stype,op,root,comm_in, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_REDUCE_SCATTER_ID)

/* ---- wrapping MPI_Reduce_scatter ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Reduce_scatter 
 * CPARAMS    MPI3CONST void *sbuf, void *rbuf, MPI3CONST int *scounts, MPI_Datatype stype, MPI_Op op, MPI_Comm comm_in
 * CARGS      sbuf,rbuf,scounts,stype,op,comm_in
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNTS_C
 * GET_RANK   IPM_MPI_RANK_ALL_C
 */

void IPM_MPI_Reduce_scatter(MPI3CONST void *sbuf, void *rbuf, MPI3CONST int *scounts, MPI_Datatype stype, MPI_Op op, MPI_Comm comm_in, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNTS_C(bytes); 
  IPM_MPI_RANK_ALL_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_REDUCE_SCATTER_ID_GLOBAL, "MPI_Reduce_scatter", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_REDUCE_SCATTER_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_REDUCE_SCATTER_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_REDUCE_SCATTER_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_REDUCE_SCATTER_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Reduce_scatter(MPI3CONST void *sbuf, void *rbuf, MPI3CONST int *scounts, MPI_Datatype stype, MPI_Op op, MPI_Comm comm_in)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Reduce_scatter(sbuf,rbuf,scounts,stype,op,comm_in);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Reduce_scatter(sbuf,rbuf,scounts,stype,op,comm_in, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_BARRIER_ID)

/* ---- wrapping MPI_Barrier ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Barrier 
 * CPARAMS    MPI_Comm comm_in
 * CARGS      comm_in
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_NONE_C
 * GET_RANK   IPM_MPI_RANK_NONE_C
 */

void IPM_MPI_Barrier(MPI_Comm comm_in, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_NONE_C(bytes); 
  IPM_MPI_RANK_NONE_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_BARRIER_ID_GLOBAL, "MPI_Barrier", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_BARRIER_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_BARRIER_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_BARRIER_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_BARRIER_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Barrier(MPI_Comm comm_in)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Barrier(comm_in);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Barrier(comm_in, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_GATHER_ID)

/* ---- wrapping MPI_Gather ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Gather 
 * CPARAMS    MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, int rcount, MPI_Datatype rtype, int root, MPI_Comm comm_in
 * CARGS      sbuf,scount,stype,rbuf,rcount,rtype,root,comm_in
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNT_C
 * GET_RANK   IPM_MPI_RANK_ROOT_C
 */

void IPM_MPI_Gather(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, int rcount, MPI_Datatype rtype, int root, MPI_Comm comm_in, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNT_C(bytes); 
  IPM_MPI_RANK_ROOT_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_GATHER_ID_GLOBAL, "MPI_Gather", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_GATHER_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_GATHER_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_GATHER_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_GATHER_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Gather(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, int rcount, MPI_Datatype rtype, int root, MPI_Comm comm_in)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Gather(sbuf,scount,stype,rbuf,rcount,rtype,root,comm_in);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Gather(sbuf,scount,stype,rbuf,rcount,rtype,root,comm_in, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_GATHERV_ID)

/* ---- wrapping MPI_Gatherv ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Gatherv 
 * CPARAMS    MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, MPI3CONST int *rcounts, MPI3CONST int *rdisp, MPI_Datatype rtype, int root, MPI_Comm comm_in
 * CARGS      sbuf,scount,stype,rbuf,rcounts,rdisp,rtype,root,comm_in
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNT_C
 * GET_RANK   IPM_MPI_RANK_ROOT_C
 */

void IPM_MPI_Gatherv(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, MPI3CONST int *rcounts, MPI3CONST int *rdisp, MPI_Datatype rtype, int root, MPI_Comm comm_in, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNT_C(bytes); 
  IPM_MPI_RANK_ROOT_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_GATHERV_ID_GLOBAL, "MPI_Gatherv", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_GATHERV_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_GATHERV_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_GATHERV_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_GATHERV_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Gatherv(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, MPI3CONST int *rcounts, MPI3CONST int *rdisp, MPI_Datatype rtype, int root, MPI_Comm comm_in)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Gatherv(sbuf,scount,stype,rbuf,rcounts,rdisp,rtype,root,comm_in);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Gatherv(sbuf,scount,stype,rbuf,rcounts,rdisp,rtype,root,comm_in, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_SCATTER_ID)

/* ---- wrapping MPI_Scatter ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Scatter 
 * CPARAMS    MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, int rcount, MPI_Datatype rtype, int root, MPI_Comm comm_in
 * CARGS      sbuf,scount,stype,rbuf,rcount,rtype,root,comm_in
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_RCOUNT_C
 * GET_RANK   IPM_MPI_RANK_ROOT_C
 */

void IPM_MPI_Scatter(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, int rcount, MPI_Datatype rtype, int root, MPI_Comm comm_in, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_RCOUNT_C(bytes); 
  IPM_MPI_RANK_ROOT_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_SCATTER_ID_GLOBAL, "MPI_Scatter", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_SCATTER_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_SCATTER_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_SCATTER_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_SCATTER_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Scatter(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, int rcount, MPI_Datatype rtype, int root, MPI_Comm comm_in)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Scatter(sbuf,scount,stype,rbuf,rcount,rtype,root,comm_in);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Scatter(sbuf,scount,stype,rbuf,rcount,rtype,root,comm_in, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_SCATTERV_ID)

/* ---- wrapping MPI_Scatterv ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Scatterv 
 * CPARAMS    MPI3CONST void *sbuf, MPI3CONST int *scounts, MPI3CONST int *sdisp, MPI_Datatype stype, void *rbuf, int rcount, MPI_Datatype rtype, int root, MPI_Comm comm_in
 * CARGS      sbuf,scounts,sdisp,stype,rbuf,rcount,rtype,root,comm_in
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_RCOUNT_C
 * GET_RANK   IPM_MPI_RANK_ROOT_C
 */

void IPM_MPI_Scatterv(MPI3CONST void *sbuf, MPI3CONST int *scounts, MPI3CONST int *sdisp, MPI_Datatype stype, void *rbuf, int rcount, MPI_Datatype rtype, int root, MPI_Comm comm_in, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_RCOUNT_C(bytes); 
  IPM_MPI_RANK_ROOT_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_SCATTERV_ID_GLOBAL, "MPI_Scatterv", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_SCATTERV_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_SCATTERV_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_SCATTERV_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_SCATTERV_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Scatterv(MPI3CONST void *sbuf, MPI3CONST int *scounts, MPI3CONST int *sdisp, MPI_Datatype stype, void *rbuf, int rcount, MPI_Datatype rtype, int root, MPI_Comm comm_in)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Scatterv(sbuf,scounts,sdisp,stype,rbuf,rcount,rtype,root,comm_in);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Scatterv(sbuf,scounts,sdisp,stype,rbuf,rcount,rtype,root,comm_in, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_SCAN_ID)

/* ---- wrapping MPI_Scan ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Scan 
 * CPARAMS    MPI3CONST void *sbuf, void *rbuf, int scount, MPI_Datatype stype, MPI_Op op, MPI_Comm comm_in
 * CARGS      sbuf,rbuf,scount,stype,op,comm_in
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNT_C
 * GET_RANK   IPM_MPI_RANK_ALL_C
 */

void IPM_MPI_Scan(MPI3CONST void *sbuf, void *rbuf, int scount, MPI_Datatype stype, MPI_Op op, MPI_Comm comm_in, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNT_C(bytes); 
  IPM_MPI_RANK_ALL_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_SCAN_ID_GLOBAL, "MPI_Scan", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_SCAN_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_SCAN_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_SCAN_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_SCAN_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Scan(MPI3CONST void *sbuf, void *rbuf, int scount, MPI_Datatype stype, MPI_Op op, MPI_Comm comm_in)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Scan(sbuf,rbuf,scount,stype,op,comm_in);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Scan(sbuf,rbuf,scount,stype,op,comm_in, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_ALLGATHER_ID)

/* ---- wrapping MPI_Allgather ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Allgather 
 * CPARAMS    MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, int rcount, MPI_Datatype rtype, MPI_Comm comm_in
 * CARGS      sbuf,scount,stype,rbuf,rcount,rtype,comm_in
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNT_C
 * GET_RANK   IPM_MPI_RANK_ALL_C
 */

void IPM_MPI_Allgather(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, int rcount, MPI_Datatype rtype, MPI_Comm comm_in, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNT_C(bytes); 
  IPM_MPI_RANK_ALL_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_ALLGATHER_ID_GLOBAL, "MPI_Allgather", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_ALLGATHER_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_ALLGATHER_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_ALLGATHER_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_ALLGATHER_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Allgather(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, int rcount, MPI_Datatype rtype, MPI_Comm comm_in)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Allgather(sbuf,scount,stype,rbuf,rcount,rtype,comm_in);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Allgather(sbuf,scount,stype,rbuf,rcount,rtype,comm_in, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_ALLGATHERV_ID)

/* ---- wrapping MPI_Allgatherv ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Allgatherv 
 * CPARAMS    MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, MPI3CONST int *rcounts, MPI3CONST int *rdisp, MPI_Datatype rtype, MPI_Comm comm_in
 * CARGS      sbuf,scount,stype,rbuf,rcounts,rdisp,rtype,comm_in
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNT_C
 * GET_RANK   IPM_MPI_RANK_ALL_C
 */

void IPM_MPI_Allgatherv(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, MPI3CONST int *rcounts, MPI3CONST int *rdisp, MPI_Datatype rtype, MPI_Comm comm_in, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNT_C(bytes); 
  IPM_MPI_RANK_ALL_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_ALLGATHERV_ID_GLOBAL, "MPI_Allgatherv", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_ALLGATHERV_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_ALLGATHERV_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_ALLGATHERV_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_ALLGATHERV_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Allgatherv(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, MPI3CONST int *rcounts, MPI3CONST int *rdisp, MPI_Datatype rtype, MPI_Comm comm_in)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Allgatherv(sbuf,scount,stype,rbuf,rcounts,rdisp,rtype,comm_in);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Allgatherv(sbuf,scount,stype,rbuf,rcounts,rdisp,rtype,comm_in, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_ALLREDUCE_ID)

/* ---- wrapping MPI_Allreduce ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Allreduce 
 * CPARAMS    MPI3CONST void *sbuf, void *rbuf, int scount, MPI_Datatype stype, MPI_Op op, MPI_Comm comm_in
 * CARGS      sbuf,rbuf,scount,stype,op,comm_in
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNT_C
 * GET_RANK   IPM_MPI_RANK_ALL_C
 */

void IPM_MPI_Allreduce(MPI3CONST void *sbuf, void *rbuf, int scount, MPI_Datatype stype, MPI_Op op, MPI_Comm comm_in, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNT_C(bytes); 
  IPM_MPI_RANK_ALL_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_ALLREDUCE_ID_GLOBAL, "MPI_Allreduce", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_ALLREDUCE_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_ALLREDUCE_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_ALLREDUCE_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_ALLREDUCE_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Allreduce(MPI3CONST void *sbuf, void *rbuf, int scount, MPI_Datatype stype, MPI_Op op, MPI_Comm comm_in)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Allreduce(sbuf,rbuf,scount,stype,op,comm_in);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Allreduce(sbuf,rbuf,scount,stype,op,comm_in, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_ALLTOALL_ID)

/* ---- wrapping MPI_Alltoall ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Alltoall 
 * CPARAMS    MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, int rcount, MPI_Datatype rtype, MPI_Comm comm_in
 * CARGS      sbuf,scount,stype,rbuf,rcount,rtype,comm_in
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNT_C
 * GET_RANK   IPM_MPI_RANK_ALL_C
 */

void IPM_MPI_Alltoall(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, int rcount, MPI_Datatype rtype, MPI_Comm comm_in, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNT_C(bytes); 
  IPM_MPI_RANK_ALL_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_ALLTOALL_ID_GLOBAL, "MPI_Alltoall", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_ALLTOALL_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_ALLTOALL_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_ALLTOALL_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_ALLTOALL_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Alltoall(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, int rcount, MPI_Datatype rtype, MPI_Comm comm_in)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Alltoall(sbuf,scount,stype,rbuf,rcount,rtype,comm_in);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Alltoall(sbuf,scount,stype,rbuf,rcount,rtype,comm_in, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_ALLTOALLV_ID)

/* ---- wrapping MPI_Alltoallv ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Alltoallv 
 * CPARAMS    MPI3CONST void *sbuf, MPI3CONST int *scounts, MPI3CONST int *sdisp, MPI_Datatype stype, void *rbuf, MPI3CONST int *rcounts, MPI3CONST int *rdisp, MPI_Datatype rtype, MPI_Comm comm_in
 * CARGS      sbuf,scounts,sdisp,stype,rbuf,rcounts,rdisp,rtype,comm_in
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNTS_C
 * GET_RANK   IPM_MPI_RANK_ALL_C
 */

void IPM_MPI_Alltoallv(MPI3CONST void *sbuf, MPI3CONST int *scounts, MPI3CONST int *sdisp, MPI_Datatype stype, void *rbuf, MPI3CONST int *rcounts, MPI3CONST int *rdisp, MPI_Datatype rtype, MPI_Comm comm_in, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNTS_C(bytes); 
  IPM_MPI_RANK_ALL_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_ALLTOALLV_ID_GLOBAL, "MPI_Alltoallv", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_ALLTOALLV_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_ALLTOALLV_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_ALLTOALLV_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_ALLTOALLV_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Alltoallv(MPI3CONST void *sbuf, MPI3CONST int *scounts, MPI3CONST int *sdisp, MPI_Datatype stype, void *rbuf, MPI3CONST int *rcounts, MPI3CONST int *rdisp, MPI_Datatype rtype, MPI_Comm comm_in)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Alltoallv(sbuf,scounts,sdisp,stype,rbuf,rcounts,rdisp,rtype,comm_in);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Alltoallv(sbuf,scounts,sdisp,stype,rbuf,rcounts,rdisp,rtype,comm_in, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_COMM_GROUP_ID)

/* ---- wrapping MPI_Comm_group ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Comm_group 
 * CPARAMS    MPI_Comm comm_in, MPI_Group *group_out
 * CARGS      comm_in,group_out
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_NONE_C
 * GET_RANK   IPM_MPI_RANK_NONE_C
 */

void IPM_MPI_Comm_group(MPI_Comm comm_in, MPI_Group *group_out, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_NONE_C(bytes); 
  IPM_MPI_RANK_NONE_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_COMM_GROUP_ID_GLOBAL, "MPI_Comm_group", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_COMM_GROUP_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_COMM_GROUP_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_COMM_GROUP_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_COMM_GROUP_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Comm_group(MPI_Comm comm_in, MPI_Group *group_out)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Comm_group(comm_in,group_out);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Comm_group(comm_in,group_out, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_COMM_COMPARE_ID)

/* ---- wrapping MPI_Comm_compare ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Comm_compare 
 * CPARAMS    MPI_Comm comm1_in, MPI_Comm comm2_in, int *result
 * CARGS      comm1_in,comm2_in,result
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_NONE_C
 * GET_RANK   IPM_MPI_RANK_NONE_C
 */

void IPM_MPI_Comm_compare(MPI_Comm comm1_in, MPI_Comm comm2_in, int *result, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_NONE_C(bytes); 
  IPM_MPI_RANK_NONE_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_COMM_COMPARE_ID_GLOBAL, "MPI_Comm_compare", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_COMM_COMPARE_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_COMM_COMPARE_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_COMM_COMPARE_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_COMM_COMPARE_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Comm_compare(MPI_Comm comm1_in, MPI_Comm comm2_in, int *result)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Comm_compare(comm1_in,comm2_in,result);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Comm_compare(comm1_in,comm2_in,result, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_COMM_DUP_ID)

/* ---- wrapping MPI_Comm_dup ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Comm_dup 
 * CPARAMS    MPI_Comm comm_in, MPI_Comm *comm_out
 * CARGS      comm_in,comm_out
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_NONE_C
 * GET_RANK   IPM_MPI_RANK_NONE_C
 */

void IPM_MPI_Comm_dup(MPI_Comm comm_in, MPI_Comm *comm_out, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_NONE_C(bytes); 
  IPM_MPI_RANK_NONE_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_COMM_DUP_ID_GLOBAL, "MPI_Comm_dup", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_COMM_DUP_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_COMM_DUP_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_COMM_DUP_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_COMM_DUP_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Comm_dup(MPI_Comm comm_in, MPI_Comm *comm_out)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Comm_dup(comm_in,comm_out);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Comm_dup(comm_in,comm_out, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_COMM_CREATE_ID)

/* ---- wrapping MPI_Comm_create ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Comm_create 
 * CPARAMS    MPI_Comm comm_in, MPI_Group group_in, MPI_Comm *comm_out
 * CARGS      comm_in,group_in,comm_out
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_NONE_C
 * GET_RANK   IPM_MPI_RANK_NONE_C
 */

void IPM_MPI_Comm_create(MPI_Comm comm_in, MPI_Group group_in, MPI_Comm *comm_out, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_NONE_C(bytes); 
  IPM_MPI_RANK_NONE_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_COMM_CREATE_ID_GLOBAL, "MPI_Comm_create", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_COMM_CREATE_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_COMM_CREATE_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_COMM_CREATE_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_COMM_CREATE_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Comm_create(MPI_Comm comm_in, MPI_Group group_in, MPI_Comm *comm_out)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Comm_create(comm_in,group_in,comm_out);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Comm_create(comm_in,group_in,comm_out, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_COMM_SPLIT_ID)

/* ---- wrapping MPI_Comm_split ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Comm_split 
 * CPARAMS    MPI_Comm comm_in, int mpicol, int mpikey, MPI_Comm *comm_out
 * CARGS      comm_in,mpicol,mpikey,comm_out
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_NONE_C
 * GET_RANK   IPM_MPI_RANK_NONE_C
 */

void IPM_MPI_Comm_split(MPI_Comm comm_in, int mpicol, int mpikey, MPI_Comm *comm_out, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_NONE_C(bytes); 
  IPM_MPI_RANK_NONE_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_COMM_SPLIT_ID_GLOBAL, "MPI_Comm_split", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_COMM_SPLIT_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_COMM_SPLIT_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_COMM_SPLIT_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_COMM_SPLIT_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Comm_split(MPI_Comm comm_in, int mpicol, int mpikey, MPI_Comm *comm_out)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Comm_split(comm_in,mpicol,mpikey,comm_out);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Comm_split(comm_in,mpicol,mpikey,comm_out, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_COMM_FREE_ID)

/* ---- wrapping MPI_Comm_free ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Comm_free 
 * CPARAMS    MPI_Comm *comm_inout
 * CARGS      comm_inout
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_NONE_C
 * GET_RANK   IPM_MPI_RANK_NONE_C
 */

void IPM_MPI_Comm_free(MPI_Comm *comm_inout, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_NONE_C(bytes); 
  IPM_MPI_RANK_NONE_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_COMM_FREE_ID_GLOBAL, "MPI_Comm_free", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_COMM_FREE_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_COMM_FREE_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_COMM_FREE_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_COMM_FREE_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Comm_free(MPI_Comm *comm_inout)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Comm_free(comm_inout);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Comm_free(comm_inout, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif



/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_IBCAST_ID)

/* ---- wrapping MPI_Ibcast ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Ibcast 
 * CPARAMS    void *sbuf, int scount, MPI_Datatype stype, int root, MPI_Comm comm_in, MPI_Request *request
 * CARGS      sbuf,scount,stype,root,comm_in,request
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNT_C
 * GET_RANK   IPM_MPI_RANK_ROOT_C
 */

void IPM_MPI_Ibcast(void *sbuf, int scount, MPI_Datatype stype, int root, MPI_Comm comm_in, MPI_Request *request, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNT_C(bytes); 
  IPM_MPI_RANK_ROOT_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_IBCAST_ID_GLOBAL, "MPI_Ibcast", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_IBCAST_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_IBCAST_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_IBCAST_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_IBCAST_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Ibcast(void *sbuf, int scount, MPI_Datatype stype, int root, MPI_Comm comm_in, MPI_Request *request)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Ibcast(sbuf,scount,stype,root,comm_in,request);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Ibcast(sbuf,scount,stype,root,comm_in,request, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif
/* NOTE: mpi_ibcast_ NOT WRAPPED */




/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_IREDUCE_ID)

/* ---- wrapping MPI_Ireduce ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Ireduce 
 * CPARAMS    MPI3CONST void *sbuf, void *rbuf, int scount, MPI_Datatype stype, MPI_Op op, int root, MPI_Comm comm_in, MPI_Request *request
 * CARGS      sbuf,rbuf,scount,stype,op,root,comm_in,request
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNT_C
 * GET_RANK   IPM_MPI_RANK_ROOT_C
 */

void IPM_MPI_Ireduce(MPI3CONST void *sbuf, void *rbuf, int scount, MPI_Datatype stype, MPI_Op op, int root, MPI_Comm comm_in, MPI_Request *request, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNT_C(bytes); 
  IPM_MPI_RANK_ROOT_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_IREDUCE_ID_GLOBAL, "MPI_Ireduce", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_IREDUCE_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_IREDUCE_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_IREDUCE_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_IREDUCE_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Ireduce(MPI3CONST void *sbuf, void *rbuf, int scount, MPI_Datatype stype, MPI_Op op, int root, MPI_Comm comm_in, MPI_Request *request)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Ireduce(sbuf,rbuf,scount,stype,op,root,comm_in,request);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Ireduce(sbuf,rbuf,scount,stype,op,root,comm_in,request, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif
/* NOTE: mpi_ireduce_ NOT WRAPPED */




/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_IREDUCE_SCATTER_ID)

/* ---- wrapping MPI_Ireduce_scatter ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Ireduce_scatter 
 * CPARAMS    MPI3CONST void *sbuf, void *rbuf, MPI3CONST int *scounts, MPI_Datatype stype, MPI_Op op, MPI_Comm comm_in, MPI_Request *request
 * CARGS      sbuf,rbuf,scounts,stype,op,comm_in,request
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNTS_C
 * GET_RANK   IPM_MPI_RANK_ALL_C
 */

void IPM_MPI_Ireduce_scatter(MPI3CONST void *sbuf, void *rbuf, MPI3CONST int *scounts, MPI_Datatype stype, MPI_Op op, MPI_Comm comm_in, MPI_Request *request, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNTS_C(bytes); 
  IPM_MPI_RANK_ALL_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_IREDUCE_SCATTER_ID_GLOBAL, "MPI_Ireduce_scatter", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_IREDUCE_SCATTER_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_IREDUCE_SCATTER_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_IREDUCE_SCATTER_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_IREDUCE_SCATTER_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Ireduce_scatter(MPI3CONST void *sbuf, void *rbuf, MPI3CONST int *scounts, MPI_Datatype stype, MPI_Op op, MPI_Comm comm_in, MPI_Request *request)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Ireduce_scatter(sbuf,rbuf,scounts,stype,op,comm_in,request);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Ireduce_scatter(sbuf,rbuf,scounts,stype,op,comm_in,request, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif
/* NOTE: mpi_ireduce_scatter_ NOT WRAPPED */




/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_IGATHER_ID)

/* ---- wrapping MPI_Igather ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Igather 
 * CPARAMS    MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, int rcount, MPI_Datatype rtype, int root, MPI_Comm comm_in, MPI_Request *request
 * CARGS      sbuf,scount,stype,rbuf,rcount,rtype,root,comm_in,request
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNT_C
 * GET_RANK   IPM_MPI_RANK_ROOT_C
 */

void IPM_MPI_Igather(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, int rcount, MPI_Datatype rtype, int root, MPI_Comm comm_in, MPI_Request *request, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNT_C(bytes); 
  IPM_MPI_RANK_ROOT_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_IGATHER_ID_GLOBAL, "MPI_Igather", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_IGATHER_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_IGATHER_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_IGATHER_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_IGATHER_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Igather(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, int rcount, MPI_Datatype rtype, int root, MPI_Comm comm_in, MPI_Request *request)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Igather(sbuf,scount,stype,rbuf,rcount,rtype,root,comm_in,request);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Igather(sbuf,scount,stype,rbuf,rcount,rtype,root,comm_in,request, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif
/* NOTE: mpi_igather_ NOT WRAPPED */




/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_IGATHERV_ID)

/* ---- wrapping MPI_Igatherv ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Igatherv 
 * CPARAMS    MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, MPI3CONST int *rcounts, MPI3CONST int *rdisp, MPI_Datatype rtype, int root, MPI_Comm comm_in, MPI_Request *request
 * CARGS      sbuf,scount,stype,rbuf,rcounts,rdisp,rtype,root,comm_in,request
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNT_C
 * GET_RANK   IPM_MPI_RANK_ROOT_C
 */

void IPM_MPI_Igatherv(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, MPI3CONST int *rcounts, MPI3CONST int *rdisp, MPI_Datatype rtype, int root, MPI_Comm comm_in, MPI_Request *request, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNT_C(bytes); 
  IPM_MPI_RANK_ROOT_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_IGATHERV_ID_GLOBAL, "MPI_Igatherv", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_IGATHERV_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_IGATHERV_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_IGATHERV_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_IGATHERV_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Igatherv(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, MPI3CONST int *rcounts, MPI3CONST int *rdisp, MPI_Datatype rtype, int root, MPI_Comm comm_in, MPI_Request *request)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Igatherv(sbuf,scount,stype,rbuf,rcounts,rdisp,rtype,root,comm_in,request);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Igatherv(sbuf,scount,stype,rbuf,rcounts,rdisp,rtype,root,comm_in,request, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif
/* NOTE: mpi_igatherv_ NOT WRAPPED */




/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_ISCATTER_ID)

/* ---- wrapping MPI_Iscatter ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Iscatter 
 * CPARAMS    MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, int rcount, MPI_Datatype rtype, int root, MPI_Comm comm_in, MPI_Request *request
 * CARGS      sbuf,scount,stype,rbuf,rcount,rtype,root,comm_in,request
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_RCOUNT_C
 * GET_RANK   IPM_MPI_RANK_ROOT_C
 */

void IPM_MPI_Iscatter(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, int rcount, MPI_Datatype rtype, int root, MPI_Comm comm_in, MPI_Request *request, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_RCOUNT_C(bytes); 
  IPM_MPI_RANK_ROOT_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_ISCATTER_ID_GLOBAL, "MPI_Iscatter", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_ISCATTER_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_ISCATTER_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_ISCATTER_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_ISCATTER_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Iscatter(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, int rcount, MPI_Datatype rtype, int root, MPI_Comm comm_in, MPI_Request *request)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Iscatter(sbuf,scount,stype,rbuf,rcount,rtype,root,comm_in,request);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Iscatter(sbuf,scount,stype,rbuf,rcount,rtype,root,comm_in,request, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif
/* NOTE: mpi_iscatter_ NOT WRAPPED */




/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_ISCATTERV_ID)

/* ---- wrapping MPI_Iscatterv ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Iscatterv 
 * CPARAMS    MPI3CONST void *sbuf, MPI3CONST int *scounts, MPI3CONST int *sdisp, MPI_Datatype stype, void *rbuf, int rcount, MPI_Datatype rtype, int root, MPI_Comm comm_in, MPI_Request *request
 * CARGS      sbuf,scounts,sdisp,stype,rbuf,rcount,rtype,root,comm_in,request
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_RCOUNT_C
 * GET_RANK   IPM_MPI_RANK_ROOT_C
 */

void IPM_MPI_Iscatterv(MPI3CONST void *sbuf, MPI3CONST int *scounts, MPI3CONST int *sdisp, MPI_Datatype stype, void *rbuf, int rcount, MPI_Datatype rtype, int root, MPI_Comm comm_in, MPI_Request *request, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_RCOUNT_C(bytes); 
  IPM_MPI_RANK_ROOT_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_ISCATTERV_ID_GLOBAL, "MPI_Iscatterv", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_ISCATTERV_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_ISCATTERV_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_ISCATTERV_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_ISCATTERV_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Iscatterv(MPI3CONST void *sbuf, MPI3CONST int *scounts, MPI3CONST int *sdisp, MPI_Datatype stype, void *rbuf, int rcount, MPI_Datatype rtype, int root, MPI_Comm comm_in, MPI_Request *request)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Iscatterv(sbuf,scounts,sdisp,stype,rbuf,rcount,rtype,root,comm_in,request);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Iscatterv(sbuf,scounts,sdisp,stype,rbuf,rcount,rtype,root,comm_in,request, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif
/* NOTE: mpi_iscatterv_ NOT WRAPPED */




/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_ISCAN_ID)

/* ---- wrapping MPI_Iscan ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Iscan 
 * CPARAMS    MPI3CONST void *sbuf, void *rbuf, int scount, MPI_Datatype stype, MPI_Op op, MPI_Comm comm_in, MPI_Request *request
 * CARGS      sbuf,rbuf,scount,stype,op,comm_in,request
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNT_C
 * GET_RANK   IPM_MPI_RANK_ALL_C
 */

void IPM_MPI_Iscan(MPI3CONST void *sbuf, void *rbuf, int scount, MPI_Datatype stype, MPI_Op op, MPI_Comm comm_in, MPI_Request *request, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNT_C(bytes); 
  IPM_MPI_RANK_ALL_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_ISCAN_ID_GLOBAL, "MPI_Iscan", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_ISCAN_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_ISCAN_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_ISCAN_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_ISCAN_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Iscan(MPI3CONST void *sbuf, void *rbuf, int scount, MPI_Datatype stype, MPI_Op op, MPI_Comm comm_in, MPI_Request *request)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Iscan(sbuf,rbuf,scount,stype,op,comm_in,request);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Iscan(sbuf,rbuf,scount,stype,op,comm_in,request, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif
/* NOTE: mpi_iscan_ NOT WRAPPED */




/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_IALLGATHER_ID)

/* ---- wrapping MPI_Iallgather ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Iallgather 
 * CPARAMS    MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, int rcount, MPI_Datatype rtype, MPI_Comm comm_in, MPI_Request *request
 * CARGS      sbuf,scount,stype,rbuf,rcount,rtype,comm_in,request
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNT_C
 * GET_RANK   IPM_MPI_RANK_ALL_C
 */

void IPM_MPI_Iallgather(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, int rcount, MPI_Datatype rtype, MPI_Comm comm_in, MPI_Request *request, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNT_C(bytes); 
  IPM_MPI_RANK_ALL_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_IALLGATHER_ID_GLOBAL, "MPI_Iallgather", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_IALLGATHER_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_IALLGATHER_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_IALLGATHER_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_IALLGATHER_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Iallgather(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, int rcount, MPI_Datatype rtype, MPI_Comm comm_in, MPI_Request *request)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Iallgather(sbuf,scount,stype,rbuf,rcount,rtype,comm_in,request);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Iallgather(sbuf,scount,stype,rbuf,rcount,rtype,comm_in,request, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif
/* NOTE: mpi_iallgather_ NOT WRAPPED */




/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_IALLGATHERV_ID)

/* ---- wrapping MPI_Iallgatherv ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Iallgatherv 
 * CPARAMS    MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, MPI3CONST int *rcounts, MPI3CONST int *rdisp, MPI_Datatype rtype, MPI_Comm comm_in, MPI_Request *request
 * CARGS      sbuf,scount,stype,rbuf,rcounts,rdisp,rtype,comm_in,request
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNT_C
 * GET_RANK   IPM_MPI_RANK_ALL_C
 */

void IPM_MPI_Iallgatherv(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, MPI3CONST int *rcounts, MPI3CONST int *rdisp, MPI_Datatype rtype, MPI_Comm comm_in, MPI_Request *request, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNT_C(bytes); 
  IPM_MPI_RANK_ALL_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_IALLGATHERV_ID_GLOBAL, "MPI_Iallgatherv", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_IALLGATHERV_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_IALLGATHERV_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_IALLGATHERV_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_IALLGATHERV_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Iallgatherv(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, MPI3CONST int *rcounts, MPI3CONST int *rdisp, MPI_Datatype rtype, MPI_Comm comm_in, MPI_Request *request)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Iallgatherv(sbuf,scount,stype,rbuf,rcounts,rdisp,rtype,comm_in,request);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Iallgatherv(sbuf,scount,stype,rbuf,rcounts,rdisp,rtype,comm_in,request, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif
/* NOTE: mpi_iallgatherv_ NOT WRAPPED */




/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_IALLREDUCE_ID)

/* ---- wrapping MPI_Iallreduce ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Iallreduce 
 * CPARAMS    MPI3CONST void *sbuf, void *rbuf, int scount, MPI_Datatype stype, MPI_Op op, MPI_Comm comm_in, MPI_Request *request
 * CARGS      sbuf,rbuf,scount,stype,op,comm_in,request
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNT_C
 * GET_RANK   IPM_MPI_RANK_ALL_C
 */

void IPM_MPI_Iallreduce(MPI3CONST void *sbuf, void *rbuf, int scount, MPI_Datatype stype, MPI_Op op, MPI_Comm comm_in, MPI_Request *request, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNT_C(bytes); 
  IPM_MPI_RANK_ALL_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_IALLREDUCE_ID_GLOBAL, "MPI_Iallreduce", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_IALLREDUCE_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_IALLREDUCE_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_IALLREDUCE_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_IALLREDUCE_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Iallreduce(MPI3CONST void *sbuf, void *rbuf, int scount, MPI_Datatype stype, MPI_Op op, MPI_Comm comm_in, MPI_Request *request)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Iallreduce(sbuf,rbuf,scount,stype,op,comm_in,request);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Iallreduce(sbuf,rbuf,scount,stype,op,comm_in,request, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif
/* NOTE: mpi_iallreduce_ NOT WRAPPED */




/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_IALLTOALL_ID)

/* ---- wrapping MPI_Ialltoall ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Ialltoall 
 * CPARAMS    MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, int rcount, MPI_Datatype rtype, MPI_Comm comm_in, MPI_Request *request
 * CARGS      sbuf,scount,stype,rbuf,rcount,rtype,comm_in,request
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNT_C
 * GET_RANK   IPM_MPI_RANK_ALL_C
 */

void IPM_MPI_Ialltoall(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, int rcount, MPI_Datatype rtype, MPI_Comm comm_in, MPI_Request *request, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNT_C(bytes); 
  IPM_MPI_RANK_ALL_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_IALLTOALL_ID_GLOBAL, "MPI_Ialltoall", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_IALLTOALL_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_IALLTOALL_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_IALLTOALL_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_IALLTOALL_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Ialltoall(MPI3CONST void *sbuf, int scount, MPI_Datatype stype, void *rbuf, int rcount, MPI_Datatype rtype, MPI_Comm comm_in, MPI_Request *request)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Ialltoall(sbuf,scount,stype,rbuf,rcount,rtype,comm_in,request);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Ialltoall(sbuf,scount,stype,rbuf,rcount,rtype,comm_in,request, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif
/* NOTE: mpi_ialltoall_ NOT WRAPPED */




/* Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#if MPI_VERSION >= 3 || IS_NOT_MPI3_CALL_ID(MPI_IALLTOALLV_ID)

/* ---- wrapping MPI_Ialltoallv ---- */
/*
 * strings in the form __IDENTIFIER__ are replaced 
 * by the wrapper script
 *
 * CRET       int
 * CFNAME     MPI_Ialltoallv 
 * CPARAMS    MPI3CONST void *sbuf, MPI3CONST int *scounts, MPI3CONST int *sdisp, MPI_Datatype stype, void *rbuf, MPI3CONST int *rcounts, MPI3CONST int *rdisp, MPI_Datatype rtype, MPI_Comm comm_in, MPI_Request *request
 * CARGS      sbuf,scounts,sdisp,stype,rbuf,rcounts,rdisp,rtype,comm_in,request
 * CFMT       __CFMT__
 * GET_BYTES  IPM_MPI_BYTES_SCOUNTS_C
 * GET_RANK   IPM_MPI_RANK_ALL_C
 */

void IPM_MPI_Ialltoallv(MPI3CONST void *sbuf, MPI3CONST int *scounts, MPI3CONST int *sdisp, MPI_Datatype stype, void *rbuf, MPI3CONST int *rcounts, MPI3CONST int *rdisp, MPI_Datatype rtype, MPI_Comm comm_in, MPI_Request *request, double tstart, double tstop)
{
  int bytes, irank;
  double t;
  int csite, idx, idx2, regid; 
  IPM_KEY_TYPE key;

  t=tstop-tstart;
  
  bytes=0; irank=0;
  
  IPM_MPI_BYTES_SCOUNTS_C(bytes); 
  IPM_MPI_RANK_ALL_C(irank);

#ifndef KEEP_BYTES_ACCURACY 
  KEEP_ONLY_HIGH_3BITS(bytes);
#endif /* KEEP_BYTES_ACCURACY */    

  if( irank==MPI_ANY_SOURCE ) {
    irank = IPM_RANK_ANY_SOURCE;
  }
  
#ifdef HAVE_CALLPATH
  csite=get_callsite_id();
#else
  csite=0;
#endif 
  
  regid=ipm_rstackptr->id;
  
  /* check for out-of-range */
  if(irank<KEY_MIN_RANK || irank>KEY_MAX_RANK) 
    irank=IPM_RANK_NULL;

  if(csite<KEY_MIN_CALLSITE || csite>KEY_MAX_CALLSITE) 
    irank=IPM_CALLSITE_NULL;

  if(regid<KEY_MIN_REGION || regid>KEY_MAX_REGION) 
    irank=IPM_REGION_NULL;

  if( bytes<0 ) {
    bytes=0;
    irank=IPM_RANK_NULL;
  }

#ifdef HAVE_MPI_TRACE
#ifndef HAVE_KEYHIST
  IPM_MPI_TRACE(tstart, tstop,MPI_IALLTOALLV_ID_GLOBAL, "MPI_Ialltoallv", 
		irank, bytes, regid, csite);
#endif /* HAVE_KEYHIST */
#endif

  
  IPM_MPI_KEY(key, MPI_IALLTOALLV_ID_GLOBAL, irank, bytes, 
	      regid, csite);

#ifdef IPM_COLLECTIVE_DETAILS 

#if IS_COLLECTIVE_CALL_ID(MPI_IALLTOALLV_ID)
  {
    int itype;
    MPITYPE_TO_IPMTYPE(stype, itype);
    KEY_SET_DATATYPE(key,itype);
  }
#endif /* collective call */
  
#if (MPI_IALLTOALLV_ID == MPI_REDUCE_ID) || (__CFID__ == MPI_SCAN_ID) || \
  (MPI_IALLTOALLV_ID == MPI_ALLREDUCE_ID)
  { 
    int iop;
    MPIOP_TO_IPMOP(op, iop);
    KEY_SET_OPERATION(key,iop);
  }
#endif

#endif /* IPM_COLLECTIVE_DETAILS */
  
  IPM_HASH_HKEY(ipm_htable, key, idx); 
  
#ifdef HAVE_KEYHIST
#ifdef HAVE_MPI_TRACE
  KEYHIST_TRACE(task.tracefile, key);
#endif

  IPM_XHASH_HKEY(ipm_xhtable,last_hkey,key,idx2);
  ipm_xhtable[idx2].t_tot+=(tstart-last_tstamp);

#ifdef KEYHIST_FULL_TIMING 
  ipm_xhtable[idx2].time[ipm_xhtable[idx2].count] =
    (tstart-last_tstamp);
#endif /* KEYHIST_FULL_TIMING */

  ipm_xhtable[idx2].count++;
  KEY_ASSIGN(last_hkey,key);
  last_tstamp=tstop;
#endif

  IPM_HASHTABLE_ADD(idx,t);
 
#ifdef HAVE_SNAP
 IPM_SNAP;
#endif
}

int MPI_Ialltoallv(MPI3CONST void *sbuf, MPI3CONST int *scounts, MPI3CONST int *sdisp, MPI_Datatype stype, void *rbuf, MPI3CONST int *rcounts, MPI3CONST int *rdisp, MPI_Datatype rtype, MPI_Comm comm_in, MPI_Request *request)
{
  int rv;
  double tstart, tstop;

  IPM_TIMESTAMP(tstart);
  rv = PMPI_Ialltoallv(sbuf,scounts,sdisp,stype,rbuf,rcounts,rdisp,rtype,comm_in,request);
  IPM_TIMESTAMP(tstop);

  if( ipm_state!=STATE_ACTIVE ) {
    return rv;
  }

  if( ipm_in_fortran_pmpi==IPM_NOT_IN_FORTRAN_PMPI ) {
    IPM_MPI_Ialltoallv(sbuf,scounts,sdisp,stype,rbuf,rcounts,rdisp,rtype,comm_in,request, tstart, tstop);
  }
 
  return rv;
}


/* End:
Ensure IPM is backwards compatible with MPI-1 and MPI-2 implementations */
#endif
/* NOTE: mpi_ialltoallv_ NOT WRAPPED */

